﻿// DoTextOK.jsx
// InDesign CS3, InDesign CS4, InDesign CS5
// © Иванюшин М.Ю., 2008, 2009, 2010  ivanyushin#yandex.ru
// Подготовка текста к верстке. Что делается в процессе работы скрипта, понятно из построчных комментариев.
// Очередность выполнения процедур подобрана в процессе тестирования.
// Одно- и двухбуквенные комментарии справа от фигурных скобок -- способ отмечать начало и конец цикла,
// он удобен при работе с распечаткой, когда есть много вложенных циклов.
//
//
#target indesign
app.scriptPreferences.version = 6; 
if(app.documents.length != 0) { // A
// Текущая версия программы (дата последней модификации)
myCurrentVersionData_xx_xx_xx = "23.07.2010";
//  коды специальных символов
myNonBreakableSpaceVariableWidth = "\u00A0";                
myNonBreakableSpaceFixedWidth = "\u202F";
myStrangeTire = "\u2212"; // это минус, "забытый" разработчиками раскладки русских букв. Он будет заменен на короткое тире, имеющееся во всех русских гарнитурах
myFractionSlash = "\u2044";
myBackSlash ="\u005C";
mySpace = "\u0020";
myThinSpace ="\u2009";
mySixthSpace ="\u2006";
myHyphen = "\u002D";
myDescritinaryHyphen = "\u00AD";
myWinWordHyphen = "\u00AC";
myNonbreakingHyphen = "\u2011";
myTab = "\u0009"; //знак табуляции, другой вариант задания:  "^t" 
myLineBreak = "\u000D"; // есть несколько символов -- разрыв строки, колонки, фрейма, страницы -- которые в панели Info отображаются одним и тем же кодом
myForcedLineBreak = "\u000A";
myDots = "\u2026";
myDeleteRepeatedEnter = true; // по умолчанию повторы перевода строки удаляются
myForbidShortWords = true;  // по умолчанию запрещено отрывать одно- и двухбуквенные предлоги (частицы, союзы) от слов, к которым они относятся
//
myFamilySpace = myNonBreakableSpaceFixedWidth; // шпация для отбивки инициалов имени о фамилии в случае: Пушкин А. или Пушкин А.С.
//
myDebug = false; // установка этого параметра равным true отключает вывод на экран progressbar-окна. Оно иногда мешает при отладке. 
myStepOfProcess =1; // номер текущего шага обработки, после которого прогресс-бар сдвинется на один шаг.
//
// Сообщения, выводимые на экран
myIndxInfoMessage = "\nимеющейся информации недостаточно для решения, что делать с текстом. \nТекст будет готов к верстке после исправления указанных ошибок набора.\nПовторного запуска этой программы не требуется."
myStyledTextMessage = "\n\nВ процессе обработки текста выделения курсивом, полужирным и курсивом+полужирным, а также верхний и нижний индексы отмечаются своими символьными стилями. \nВ зависимости от содержимого обрабатываемого файла могут появиться такие стили символов — myItalicChars, myBoldChars, myBoldItalicChars, mySupChars, mySybChars. \nЭти стили красят эти слова цветом myInfoColor, чтобы не потерять имеющуюся авторскую разметку при стилевом оформлении в процессе верстки."
//myAccentMessage ="\n\nВ верстке есть одиночные гласные курсивные буквы среди прямых. Возможно, это авторское обозначение ударных гласных, эти буквы отмечены символьным стилем myAccent, в котором определен цвет myAccentedVocals."
myLetterPeriodLetterMessage = "\n\nВстречены символы, разделенные точкой, после которой нет пробела, это может быть как часть электронного адреса или адреса сайта, так и ошибка набора, например, потеря пробела после точки между предложениями. Эти случаи окрашены цветом myInfoColor, и решение, нужен пробел после точки или нет, должно быть принято в процессе верстки."
myStrangePunctuationMessage = "\n\nВстречено неясное использование знаков пунктуации. Эти случаи отмечены стилем myPayAttention (определен только цвет myInfoColor)."
myBadParaFoundMessage = "\n\nВстречены абзацы, последний символ которых отличается от следующих:   .   ;   :   …   —   !   ?  *.\nТакие строки могут быть в стихах или заголовках, в других случаях это, скорее всего, ошибка набора.\nДля нахождения встреченных оборванных строк перед знаком перевода строки поставлен пробел."
//
// Код любого специального символа можно узнать так: ввести этот символ Type > Insert... , а затем выделить и посмотреть в палитре Info
//
var myProgramTitulWholeText = " Подготовка текста к верстке " +"(версия " +myCurrentVersionData_xx_xx_xx +" )" +"  © Михаил Иванюшин, 2010 ";
var myProgramTitulFragment = " Обработка фрагмента текста верстки  " +"(версия " +myCurrentVersionData_xx_xx_xx +" )" +"  © Михаил Иванюшин, 2010 ";
var myProgramTitul = myProgramTitulWholeText;
// ***  Варианты тире со стандартными отбивками ***
mySpaceDashSpace  = "^S— "; // Тире, обрамленное пробелами, первый из которых неразбиваемый фиксированой ширины
mySpaceMinusSpace  = "^S– "; // Минус, обрамленный пробелами, первый из которых неразбиваемый фиксированой ширины
//
// переменная myDashSeparator используется как тире со стандартными отбивками при подготовке текста к верстке
var myDashSeparator = mySpaceDashSpace; 
// *** Разделитель между цифрами в датах и числовых интервалах ***
myInterDigitMinus = "–";  // "\u2013"
myInterDigitTire = "—";   // "\u2014"
var myInterDigitSeparator = myInterDigitMinus;
//
myPhoneProcessing =true; // по умолчанию предполагается, что обработка телефонных номеров будетпроизводиться .
// *** Варианты формата представления 7-значного телефонного номера ***
mySample322 = "000-00-00";
mySample34 = "000-0000";
var myPhoneSample = mySample322;
// Эта программа предполагает, что есть только два таких варианта описания семизначных номеров.
// Если появятся другие, нужна правка функции myRightPhoneNote() 
// ***
// разделитель групп цифр в номере телефона, 
mySeparatorIsDefis = myNonbreakingHyphen; // неразрывный дефис в качестве разделителя
mySeparatorIsSpace= myNonBreakableSpaceFixedWidth; // неразрывный фиксированный пробел в качестве разделителя
var myPhoneDigitSeparator = mySeparatorIsDefis;
//
myViewWithPoint = 0; // сокращения пишем с точкой: млн., млрд,
myViewEmpty = 1; // сокращения пишем без точки: млн., млрд,
var myBigValueView = myViewWithPoint; // стандартное значение отбивки
//
var myIndxStart; // индекс начала выделенного фрегмента текста в статье.
var myFragment = false; // указатель, проверяется вся статья (false) или только фрагмент (true)
//
myProcOnly = 0; // между процентом и числом отбивки нет
myProcAndSpace =1; // между процентом и числом отбивка (тонкая шпация)
var myViewProc = myProcOnly; // стандартное оформление процентов и промилле
myProcSeparator = myThinSpace; // это стандартное значение отбивки.
//
mySelectionOn = 0; //предполагаем, что пользователю не нужно запоминать информацию о выделениях символов  в тексте курсивом и полужирным
//***
var myInfoColorSample = new Array;
// myInfoColorSample — шаблон цвета для myInfoColor
myInfoColorSample = [0, 100, 100, 0]; 
// myModifiedCharSample — шаблон цвета для mySepChar
myModifiedCharSample = [0, 0, 0, 100]; 
// myAccentedVocalsSample — шаблон цвета для myAccentedVocals
myAccentedVocalsSample= [0, 100, 100, 0]; 
// myRightChars — массив символов, которые могут быть концом абзаца. 
// Если перед знаком перевода строки любой другой символ, считаем, что при наборе допущена ошибка
myRightChars = [".", ";", ":", "…", "—",  "!","?" ,"*"];
var myBadParaFound = 0; // переменная отлична от нуля, если встречен абзац, последний символ в котором отличен от перечисленных в массиве myRightChars[ ]
// myDigitSeparator — это разделитель цифр,  т.е. символ, использующийся для замены пробела между цифрами в функции mySetRightSpaceBetweenDigits
myDigitSeparator = myThinSpace;
var myStrangePunctuation =0;
var myAccentIsDetected = false; // переменная будет true, если встретятся одиночные курсивные буквы, предположительно авторское обозначение ударения
//
var mySelection = app.selection[0];
var myDocument = app.documents.item(0);
var myColor, myName;
var myFound;
var myLine;
var myIndx;
var myTornPara =0; // ноль, если нет оборванных абзацев
var myStyledText=0; // переменная будет отлична от нуля, если в тексте будут курсив, полужирный или верхний или нижний индексы
var myLetterPeriodLetter=0; //  переменная будет отлична от нуля, если в тексте встретится точка, после которой не пробела
//
with (app) { ////
if(app.selection.length != 0) { // R
		switch(mySelection.constructor.name) { // switch
			case "Text":
			case "InsertionPoint":
			case "Character":
			case "Word":
			case "Line":
			case "TextStyleRange":
			case "Paragraph":
			case "TextColumn":
			//case "TextFrame":
		//	if(app.selection.length != 0) { // B
		
var myStory = mySelection.parentStory;
var myCharsOrig = mySelection.characters.length;
var myParsOrig = mySelection.paragraphs.length;
if (myStory.characters.length <= 1) { // 0 - ничего нет. 1 - только один знак перевода строки
 alert("В фрейме текста нет.\n", myProgramTitul);	
 exit();
} //0		
if (myCharsOrig == 0) { //ON   // не выделен ни один символ, значит, обрабатывается вся статья
	var myText = myStory;
	var myCharsOrig = myStory.characters.length;
	var myParsOrig = myStory.paragraphs.length;
	myIndxStart =0;
	myFragment = false;
	myProgramTitul = myProgramTitulWholeText;
	} //ON
else   { //KV
//		расширим выделенную область до кратности абзацам
		var myStartOfFragment = mySelection.paragraphs[0].characters.firstItem().index;
		var myEndOfFragment = mySelection.paragraphs[mySelection.paragraphs.length - 1].characters.lastItem().index;
		myIndxStart = myStartOfFragment;
		myFragment = true;
		myProgramTitul = myProgramTitulFragment;
		mySelection.parent.characters.itemByRange(myStartOfFragment ,myEndOfFragment - 1).select();
		} //KV
//*
var myLineWithNameOfIniFile = myFile("DoTextOK.ini");
var myIniFile = new File (myLineWithNameOfIniFile);
var mySetInfoFile = myIniFile;
if (mySetInfoFile.exists) { //file exists
	mySetInfoFile.open("r");
	myVidTire = mySetInfoFile.readln();
	mySepInYears = mySetInfoFile.readln();
	mySelectedVarPhoneNumber = mySetInfoFile.readln();
	mySelectedVarDigSeparator = mySetInfoFile.readln();
	myDotOrNot = mySetInfoFile.readln();
	myProcMille = mySetInfoFile.readln();
	myRepEntSel = mySetInfoFile.readln();
	myVarPredlogs = mySetInfoFile.readln();
	myMakeIndexStyle = mySetInfoFile.readln();
	mySemiDigitNumber = mySetInfoFile.readln();
	myAugmentSelection = mySetInfoFile.readln();
	mySetRussLangSelection = mySetInfoFile.readln();
	myTabRemove = mySetInfoFile.readln();
	myHyphenationCharsRemove = mySetInfoFile.readln();
	myListsRemove = mySetInfoFile.readln();
	myHyperlinksRemove = mySetInfoFile.readln();
	myIniFile.close();
} //file exists
else { //script is runned first time
	myVidTire = 0;
	mySepInYears = 0;
	mySelectedVarPhoneNumber = 0;
	mySelectedVarDigSeparator = 0;
	myDotOrNot = 0;
	myProcMille = 0;
	myRepEntSel = 0;
	myVarPredlogs = 0;
	myMakeIndexStyle = 0;
	mySemiDigitNumber = 0;
	myAugmentSelection = 1;
	mySetRussLangSelection = 1;
	myTabRemove = 1;
	myHyphenationCharsRemove = 1;
	myListsRemove = 0;
	myHyperlinksRemove = 1;
}  //script is runned first time
// *** выбор параметров замены ***
mySelectParametersDialog(mySetInfoFile);
// *** выбор сделан ***
var myDate = new Date;
var myHour = myDate.getHours();
var myMinutes = myDate.getMinutes();
var mySecondes = myDate.getSeconds();
if (myFragment == true) { //TB
	app.cut();	 // выделенный фрегмент взят в буфер. Смещение от начала текста хранится в переменной myIndxStart
	with (app) { //2
	var myDoc = activeDocument;
	var myObject = myDoc.textFrames.add();
	} //2
myObject.contents = "*"; // содержимое — один символ, чтобы было что заменить на таблицу из буфера
var myText = myObject.parentStory;
var myA = app.select(myText.characters[0]); // выделили этот символ
app.paste();
myTxtProcessing(myProgramTitul,myHour,myMinutes,mySetInfoFile); // информация о времени нужна для вывода ее в шапке прогресс-бара
// удаляем знаки перевода строки в начале и конце текста, оставшиеся после обработки
myText.characters.lastItem().remove();
myText.characters.firstItem().remove();
//
myText.characters.itemByRange(0,(myText.length - 1)).select();
app.copy(); // обработанный фрагмент в буфере
myObject.remove(); // удален вспомогательный фрейм
myStory.insertionPoints[myIndxStart].contents = '*';
var myA = app.select(myStory.characters[myIndxStart]); // выделили этот символ
app.paste();
alert("Фрагмент текста верстки приведен в порядок.\n", myProgramTitul);	
exit();
	} //TB
if (myFragment == false) myTxtProcessing(myProgramTitul,myHour,myMinutes,mySetInfoFile); // информация о времени нужна для вывода ее в шапке прогресс-бара
// Если есть символы, разделенные точкой, после которой нет пробела, то это может быть как часть электронного адреса или адреса сайта, так и ошибка набора.
// Чтобы при верстке на эти буквы обратили внимание, окрасим их 
//app.findTextPreferences = app.changeTextPreferences = NothingEnum.nothing;
//if (myFragment == true) { app.findChangeTextOptions.includeFootnotes = false; } else { app.findChangeTextOptions.includeFootnotes = true; }
app.findChangeTextOptions.includeFootnotes = true;
app.findTextPreferences.findWhat = "^$.^$" ; // маска поиска
myFound = myText.findText(); //собрана коллекция искомых элементов в статье.
if (myFound.length != 0) { //L5#
	myLetterPeriodLetter++;
// цикл по числу элементов коллекции. Движение снизу вверх
    try{ //4
	 myColor = myDocument.colors.item("myInfoColor");
	 myName = myColor.name;
    }  //4
    catch (myError) { //3
	 myColor = myDocument.colors.add ({name:"myInfoColor", model:ColorModel.process, space:ColorSpace.CMYK, colorValue:myInfoColorSample});
    } //3	
	try{
	myDocument.characterStyles.item("myCharPointChar").name;
	}
	catch (myError){
	myDocument.characterStyles.add({name:"myCharPointChar"});
	}
	myDocument.characterStyles.item("myCharPointChar").fillColor = "myInfoColor";
	for (j=myFound.length-1; j >= 0; j--){ // N5	
	myLine = myFound[j] ;
	//myLine.appliedCharacterStyle = myDocument.characterStyles.item("myCharPointChar");
	myLine.fillColor = "myInfoColor";
 }  // N5#
} //L5#
// другие встреченные "перлы" набора
//myPayAttention(".-,");
myPayAttention(",,");
//myPayAttention(",.");
myPayAttention(",!");
myPayAttention(",?");
myPayAttention("!,");
myPayAttention("?,");
myPayAttention(":.");
//myPayAttention(".:");
myPayAttention(";.");
//myStepByStep(myProgressPanel,myProgressIndex,myIncrement); //14
//**********
var myInfo = new Array;
var myIndxInfo=0;
var myInfoMessage;	
//mySimpleChange(mySpace + myForcedLineBreak ,myForcedLineBreak); // удаление пробелов после символа принудительного перевода строки, если они есть
//mySimpleChange(myForcedLineBreak + mySpace,myForcedLineBreak); // удаление пробелов перед символом принудительного перевода строки, если они есть
myNotSolvedProblem(myForcedLineBreak,"принудительные переводы строки, возможно, это авторская псевдоверстка,");
myNotSolvedProblem("- ","слова, разделенные дефисом и пробелом,");
myNotSolvedProblem(" -","слова, разделенные пробелом и дефисом,");
myNotSolvedProblem(" –","слова, разделенные пробелом и минусом,");
 if (myDashSeparator != mySpaceMinusSpace) myNotSolvedProblem("– ","слова, разделенные минусом и пробелом,"); // Когда myDashSeparator = mySpaceMinusSpace, программа сама создает такие слова.
// Другое дело, что в тексте могли остаться слова, разделенные знаком минус, и это была ошибка набора. Поэтому целесообразнее было бы здесь использовать при обработке текста стандартное длинное тире,
// а замену этого тире на минус делать стандартным инструментом Find/Change программы InDesign.
//
if (myText.characters.length <= 1) { // 0 - ничего нет. 1 - только один знак перевода строки
 alert("После удаления повторяющихся знаков выяснилось, что текста нет.\n", myProgramTitul);	
exit();
}
//
myTornParagraph(); // поиск оборванных абзацев (myBadParaFound > 0, если такие абзацы найдутся)
//
// Если нет пробела перед знаком перевода строки -- признака, что строка оборвана, то знак перевода строки удаляется
if (myText.characters.lastItem().contents == "\r" && myText. characters.item(-2).contents != " ") myText.characters.lastItem().remove(); 
//
var myDate = new Date;
var myHourFinis = myDate.getHours();
var myMinutesFinis = myDate.getMinutes();
var mySecondesFinis = myDate.getSeconds();
var myMinutesOverflow = 0;
var mySecondesOverflow = 0;
myHourFinis = myHourFinis - myHour;
myMinutesFinis = myMinutesFinis - myMinutes;
mySecondesFinis = mySecondesFinis - mySecondes;
if (mySecondesFinis <0) { //SW
	myMinutesFinis--;	
	if (mySecondesFinis != 0) { mySecondesFinis = 60 + mySecondesFinis; }
	} //SW
if (myMinutesFinis < 0)  { //DR
	myHourFinis--;
	if (myMinutesFinis != 0) { myMinutesFinis = 60 + myMinutesFinis; }
	} //DR
if (myHourFinis <10) myHourFinis = "0" + myHourFinis;
if (myMinutesFinis <10) myMinutesFinis = "0" + myMinutesFinis;
if (mySecondesFinis <10) mySecondesFinis = "0" + mySecondesFinis;
var myChars = myText.characters.length;
var myPars = myText.paragraphs.length;
var myTimeFinis = "\n\nОбъем текста до/после обработки [символов:абзацев] — " + myCharsOrig +":"+myParsOrig + "/" +myChars +":"+myPars +". " + " Время работы программы [ч:м:с]: "  + myHourFinis +":"  + myMinutesFinis + ":" + mySecondesFinis+ "." ;
if 	(myIndxInfo !=0) {
	myInfo[myIndxInfo]=myIndxInfoMessage;
	myLastWord  = myInfo.join (' \n');	
	} 
else
	myLastWord = "Текст к верстке готов.";
if (myStyledText !=0) { //I
	myInfoMessage = myStyledTextMessage;
	myLastWord = myLastWord + myInfoMessage;
	} //I    
if (myAccentIsDetected == true) {
		myInfoMessage = myAccentMessage;
		myLastWord = myLastWord + myInfoMessage;
		}  
if (myLetterPeriodLetter !=0) { // IO
		myInfoMessage = myLetterPeriodLetterMessage;
	myLastWord = myLastWord + myInfoMessage;
		} // IO   
if (myStrangePunctuation != 0) {
	myInfoMessage = myStrangePunctuationMessage;
	myLastWord = myLastWord + myInfoMessage;
	}  
if (myBadParaFound > 0) { //HJ
	myInfoMessage = myBadParaFoundMessage;
	myLastWord = myLastWord + myInfoMessage;
	} //HJ   
myLastWord = myLastWord + myTimeFinis;
alert(myLastWord, myProgramTitul);
//}  // DialogShow
exit();
//} // B
} // switch
} // R 
} ////
alert("Перед запуском программы поставьте курсор в текст для подготовки всей статьи к верстке.\nДля обработки части текста выделите его фрагмент.", myProgramTitul);	
exit();
} // A 
alert("Нет открытых документов.", myProgramTitul);	
exit();
function mySimpleRepeatedChange(myFindWhat,myChahgeTo) { // W    //замена одной последовательности одинаковых знаков на один такой знак
app.findTextPreferences = NothingEnum.nothing;
app.changeTextPreferences = NothingEnum.nothing;
app.findTextPreferences.findWhat = myFindWhat;
app.changeTextPreferences.changeTo = myChahgeTo;
myFound = myText.changeText();
while (myFound.length !=0) { //1
    myFound = myText.changeText();
	} //1
} // W
function mySimpleChange(myFindWhat,myChahgeTo) { // W    //замена одной последовательности знаков на другую
app.findTextPreferences = NothingEnum.nothing;
app.changeTextPreferences = NothingEnum.nothing;
app.findTextPreferences.findWhat = myFindWhat;
app.changeTextPreferences.changeTo = myChahgeTo;
myText.changeText();
} // W
function myNoBreakedChars() { //myNoBreakedChars
var myLetters_1 = '(\\bне[a-zA-Zа-яА-Я]|\\bНе[a-zA-Zа-яА-Я]|\\bНЕ[a-zA-Zа-яА-Я])';	
var myLetters_2 = '([a-zA-Zа-яА-Я]не\\b|[a-zA-Zа-яА-Я]НЕ\\b)';
var myLetters_3 = '(\\bни[a-zA-Zа-яА-Я]|\\bНи[a-zA-Zа-яА-Я]|\\bНИ[a-zA-Zа-яА-Я])';	
var myLetters_4 = '([a-zA-Zа-яА-Я]ни\\b|[a-zA-Zа-яА-Я]НИ\\b)';
myNBC(myLetters_1);
myNBC(myLetters_2);
myNBC(myLetters_3);
myNBC(myLetters_4);
} //myNoBreakedChars
/////
function myNBC(LineOfChars) { //myNBC
app.findGrepPreferences = NothingEnum.nothing;
app.findGrepPreferences.findWhat = LineOfChars;				
myFoundSamples = myText.findGrep();
if (myFoundSamples.length != 0) {
// цикл по числу элементов коллекции. Движение снизу вверх
    for (j=myFoundSamples.length-1; j >= 0; j--) {	
		myLine = myFoundSamples[j];
		myLine.characters.itemByRange(0,(myLine.length-1)).noBreak = true;
	}
}
} //myNBC
function myOneLetterDefisWord() { //myOneLetterDefisWord
// ищем слово, начинающееся с буквы и дефиса и заменяем дефис на неразрывный
var myLetterAndDefis = '(\\b[a-zA-Zа-яА-Я]-)';	
app.findGrepPreferences = NothingEnum.nothing;
app.findGrepPreferences.findWhat = myLetterAndDefis;				
myFoundSamples = myText.findGrep();
a=0;
if (myFoundSamples.length != 0) {
// цикл по числу элементов коллекции. Движение снизу вверх
    for (j=myFoundSamples.length-1; j >= 0; j--) {	
		myLine = myFoundSamples[j];
		myLine.characters.item(1).contents  = myNonbreakingHyphen;	
	}
}
} //myOneLetterDefisWord
function myNobrkSpaceInserting(mySample,myIndex){ //E
app.findTextPreferences = app.changeTextPreferences = NothingEnum.nothing;
app.findTextPreferences.findWhat = mySample; // маска поиска
myFound = myText.findText(); //собрана коллекция искомых элементов в статье.
if (myFound.length !=0) { //L4
// цикл по числу элементов коллекции. Движение снизу вверх
    for (j=myFound.length-1; j >= 0; j--) { // N4	
	myLine = myFound[j] ;
	if (myIndex ==1) // заменяем обычный пробел на неразрывный
		{ myLine.characters.item(myIndex).contents  = myNonBreakableSpaceVariableWidth; continue; }
	if (myIndex ==-1) //PL такое значение индекса только в случае поиска букв "<буква>не "
		// // достаточно атрибута No Break для букв, пробел остается обычным. 
		// Женское имя-отчество (Анна Ивановна) в дательном падеже -- два неразрывных пробела после -не -- словесная конструкция из трех слов может стать слишком длинной
		{ myLine.characters.itemByRange(0,(myLine.length - 2)).noBreak = true; continue; }
	if (myIndex ==2) // в случае " не<буква>" пробел оставлен обычным, атрибут noBreak имеют только "не<буква>"
		{ myLine.characters.itemByRange(1,(myLine.length-1)).noBreak = true; continue; }
	} //N4
} //L4
} //E
function myMinusInserting(mySample){ //U
app.findTextPreferences = app.changeTextPreferences = NothingEnum.nothing;
app.findChangeTextOptions.includeFootnotes = true; 
app.findTextPreferences.findWhat = mySample; // маска поиска
myFound = myText.findText(); //собрана коллекция искомых элементов в статье.
//var mySeparator = mySpaceDashSpace;
if (myFound.length !=0) { //L3
// цикл по числу элементов коллекции. Движение снизу вверх
    for (j=myFound.length-1; j >= 0; j--){ // N3	
	myLine = myFound[j] ;
// вставляем минус
myLine.characters.item(1).contents  = "–";	
	} //N3
 } //L3
} //U
function myDigitAndUnit(mySample) { //T
    try{ //4
	 myColor = myDocument.colors.item("myModifiedChars");
	 myName = myColor.name;
    }  //4
    catch (myError) { //3
	 myColor = myDocument.colors.add ({name:"myModifiedChars", model:ColorModel.process, space:ColorSpace.CMYK, colorValue:myModifiedCharSample});
    } //3
app.findTextPreferences = app.changeTextPreferences = NothingEnum.nothing;
app.findChangeTextOptions.includeFootnotes = true;
app.findTextPreferences.findWhat = mySample; // маска поиска
myFound = myText.findText(); //собрана коллекция искомых элементов в статье.
if (myFound.length !=0) { //L5
// цикл по числу элементов коллекции. Движение снизу вверх
    for (j=myFound.length-1; j >= 0; j--){ // N5	
	myLine = myFound[j] ;
	myLine.fillColor = "myModifiedChars";
	// вставляем неразбиваемый пробел после цифры
	myLine.insertionPoints[1].contents = myNonBreakableSpaceVariableWidth;
	} //N5
} //L5
} //T
function myVek(mySample) { //T
app.findTextPreferences = app.changeTextPreferences = NothingEnum.nothing;
app.findChangeTextOptions.includeFootnotes = true;
app.findTextPreferences.findWhat = mySample; // маска поиска
myFound = myText.findText(); //собрана коллекция искомых элементов в статье.
if (myFound.length !=0) { //L5
// цикл по числу элементов коллекции. Движение снизу вверх
    for (j=myFound.length-1; j >= 0; j--){ // N5	
	myLine = myFound[j] ;
	// вставляем неразбиваемый пробел после цифры
	myLine.characters.item(1).contents = myNonBreakableSpaceVariableWidth;
	} //N5
} //L5
} //T
function myDigitAndUnitAndSpace(mySample) { //T
app.findTextPreferences = app.changeTextPreferences = NothingEnum.nothing;
app.findChangeTextOptions.includeFootnotes = true;
app.findTextPreferences.findWhat = mySample; // маска поиска
myFound = myText.findText(); //собрана коллекция искомых элементов в статье.
if (myFound.length !=0) { //L5
// цикл по числу элементов коллекции. Движение снизу вверх
    for (j=myFound.length-1; j >= 0; j--){ // N5	
	myLine = myFound[j] ;
	myLine.characters.itemByRange(1,1).remove();	// удаляем обычный пробел после цифры
	// вставляем неразбиваемый пробел после цифры
	myLine.insertionPoints[1].contents = myNonBreakableSpaceVariableWidth;
	} //N5
} //L5
} //T
function myMinusBetweenDigits(mySample,myStartIndex,myEndIndex) { //K
app.findTextPreferences = app.changeTextPreferences = NothingEnum.nothing;
app.findTextPreferences.findWhat = mySample; // маска поиска 
myFound = myText.findText(); //собрана коллекция искомых элементов в статье.
//var mySeparator = mySpaceDashSpace;
if (myFound.length !=0) { //L3
// цикл по числу элементов коллекции. Движение снизу вверх
    for (j=myFound.length-1; j >= 0; j--){ // N3	
	myLine = myFound[j] ;
// вставляем минус вместо первого элемента коллекции
	myLine.characters.item(1).contents  = "–";	
// Удаляем оставшиеся элементы коллекции
	myLine.characters.itemByRange(myLine.characters.item(myStartIndex), myLine.characters.item(myEndIndex)).remove();	
	} //N3
} //L3
} //K
function myNonBreakHyphBetweenDigitAndLetter(mySample, myCheck) { //D
app.findTextPreferences = app.changeTextPreferences = NothingEnum.nothing;
app.findTextPreferences.findWhat = mySample; // маска поиска 
myFound = myText.findText(); //собрана коллекция искомых элементов в статье.
if (myFound.length !=0) { //F
// цикл по числу элементов коллекции. Движение снизу вверх
    for (j=myFound.length-1; j >= 0; j--){ // G	
	myLine = myFound[j] ;
// вставляем неразбиваемый дефис вместо первого элемента коллекции
	myLine.characters.item(1).contents  = myNonbreakingHyphen;	
// Если между цифрой и буквой два символа, то второй удаляется
	if (myCheck==0) myLine.characters.itemByRange(2, 2).remove();	
	} //G
} //F
} //D
function mySelectedInterDigitSign() { //AQ
var myCh0;	
var myCh1;
app.findTextPreferences = app.changeTextPreferences = NothingEnum.nothing;
app.findChangeTextOptions.includeFootnotes = true; 
app.findTextPreferences.findWhat = "^9" + "–" + "^9" ; // ищем цифры, разделенные минусом 
myFound = myText.findText(); //собрана коллекция искомых элементов в статье
if (myFound.length !=0) { //L3
// цикл по числу элементов коллекции. Движение снизу вверх
    for (j=myFound.length-1; j >= 0; j--){ // N3	
	myLine = myFound[j] ;
// вставляем вместо минуса тире
	myLine.characters.item(1).contents  = "—";	
   } //N3
} //L3
app.findTextPreferences = app.changeTextPreferences = NothingEnum.nothing;
app.findChangeTextOptions.includeFootnotes = true; 
app.findTextPreferences.findWhat = "^$–^$"; // разделитель минус
myFound = myText.findText(); //собрана коллекция искомых элементов в статье.
for (j=myFound.length-1; j >= 0; j--){ // N5~	 
myLine = myFound[j] ;
myChr0 = myLine.characters.firstItem().contents;
myChr1 = myLine.characters.lastItem().contents;
if ((myRImLetterIs (myChr0) == true) && (myRImLetterIs (myChr1) == true)) { // DE
	myLine.characters.item(1).contents  = "—";   // тире
		} // DE
	} //N5~
} //AQ
function myNotSolvedProblem(mySample, myStringInfo) { //L
app.findTextPreferences = app.changeTextPreferences = NothingEnum.nothing;
if (mySample == " –") {mySample = " –^$"; } // если шаблон поиска 'пробел''минус', то он недопустим, если за ним идет буква.
app.findTextPreferences.findWhat = mySample; // маска поиска
myFound = myText.findText();
if (myFound.length !=0) { //M
	if (myIndxInfo==0) { //BB
		myInfo[myIndxInfo]="При обработке текста встречены:\n";
		myIndxInfo++;		
		} //BB
	myInfo[myIndxInfo]=myStringInfo;
	myIndxInfo++;
	} //M
} //L
function myVopreviykh(myLetter) { //F
var myStrokaFind;
var myStrokaChange;
app.findTextPreferences = NothingEnum.nothing;
app.changeTextPreferences = NothingEnum.nothing;
myStrokaFind = myLetter + mySpace + myHyphen;
app.findTextPreferences.findWhat = myStrokaFind;
myStrokaChange = myLetter+myNonbreakingHyphen;
app.changeTextPreferences.changeTo = myStrokaChange;
myText.changeText();
//
app.findTextPreferences = NothingEnum.nothing;
app.changeTextPreferences = NothingEnum.nothing;
myStrokaFind = myLetter + myHyphen + mySpace ;
app.findTextPreferences.findWhat = myStrokaFind;
myStrokaChange = myLetter+myNonbreakingHyphen;
app.changeTextPreferences.changeTo = myStrokaChange;
myText.changeText();
//
app.findTextPreferences = NothingEnum.nothing;
app.changeTextPreferences = NothingEnum.nothing;
myStrokaFind = myLetter + myHyphen;
app.findTextPreferences.findWhat = myStrokaFind;
myStrokaChange = myLetter+myNonbreakingHyphen;
app.changeTextPreferences.changeTo = myStrokaChange;
myText.changeText();
} //F
function myTwoLetterAbridge() { //E~~
var myStrokaFind;
var myStrokaChange;
app.findTextPreferences = NothingEnum.nothing;
app.changeTextPreferences = NothingEnum.nothing;
//if (myFragment == true) { app.findChangeTextOptions.includeFootnotes = false; } else { app.findChangeTextOptions.includeFootnotes = true; }
app.findChangeTextOptions.includeFootnotes = true;
app.findTextPreferences.findWhat = "^$." + mySpace + "^$.";
myFound = myText.findText(); //собрана коллекция искомых элементов в статье.
if (myFound.length !=0) { //LL
// цикл по числу элементов коллекции. Движение снизу вверх
    for (j=myFound.length-1; j >= 0; j--){ // NN	
	myLine = myFound[j] ;
// вставляем тонкую шпацию вместо пробела
	/* var myCh0 = myLine.characters.item(0).contents;
	var myCh1 = myLine.characters.item(3).contents;
	// обрабатывается только пара букв в одинаковом регистре: 'т. к.' или  'И. О.'	
	if 	((myUpperCaseLetterIs(myCh0) == false) && (myUpperCaseLetterIs(myCh1) == false)  || (myUpperCaseLetterIs(myCh0) != false) && (myUpperCaseLetterIs(myCh1) != false) ) { */
		myLine.characters.item(2).contents  = myThinSpace;
		//}
	} // NN
 } //LL
app.findTextPreferences = NothingEnum.nothing;
app.changeTextPreferences = NothingEnum.nothing;
//if (myFragment == true) { app.findChangeTextOptions.includeFootnotes = false; } else { app.findChangeTextOptions.includeFootnotes = true; }
app.findChangeTextOptions.includeFootnotes = true;
app.findTextPreferences.findWhat = "^$.^$.";
myFound = myText.findText(); //собрана коллекция искомых элементов в статье.
if (myFound.length !=0) { //LL
// цикл по числу элементов коллекции. Движение снизу вверх
    for (j=myFound.length-1; j >= 0; j--){ // NN	
	myLine = myFound[j] ;
// вставляем тонкую шпацию после первой точки
	/* var myCh0 = myLine.characters.item(0).contents;
	var myCh1 = myLine.characters.item(2).contents;
	// обрабатывается только пара букв в одинаковом регистре: 'т.к.' или  'И.О.'	
	if 	((myUpperCaseLetterIs(myCh0) == false) && (myUpperCaseLetterIs(myCh1) == false) || (myUpperCaseLetterIs(myCh0) != false) && (myUpperCaseLetterIs(myCh1) != false)) {*/
		myLine.insertionPoints[2].contents = myThinSpace;
		//}
	} // NN
 } //LL
app.findTextPreferences = NothingEnum.nothing;
app.changeTextPreferences = NothingEnum.nothing;
myStrokaFind = " в т.ч.";
app.findTextPreferences.findWhat = myStrokaFind;
myStrokaChange = " в" +myNonBreakableSpaceVariableWidth + "т."+myThinSpace + "ч.";
app.changeTextPreferences.changeTo = myStrokaChange;
myText.changeText();
//
app.findTextPreferences = NothingEnum.nothing;
app.changeTextPreferences = NothingEnum.nothing;
myStrokaFind = " в т. ч.";
app.findTextPreferences.findWhat = myStrokaFind;
myStrokaChange = " в" +myNonBreakableSpaceVariableWidth + "т."+myThinSpace + "ч.";
app.changeTextPreferences.changeTo = myStrokaChange;
myText.changeText();
} //E~~
function mySetRightSpaceBetweenDigits() { //Y
app.findTextPreferences = NothingEnum.nothing;
app.changeTextPreferences = NothingEnum.nothing;
app.findTextPreferences.findWhat = "^9 ^9";  
myFound = myText.findText(); //собрана коллекция искомых элементов в статье.
if (myFound.length !=0) { //LL
// цикл по числу элементов коллекции. Движение снизу вверх
    for (j=myFound.length-1; j >= 0; j--){ // NN	
	myLine = myFound[j] ;
	myLine.characters.item(1).contents  = myDigitSeparator;
	} // NN
 } //LL
} //Y
function myNobrkSpaceAfterShortWord(myShortWord) { //X
var myStrokaFind;
var myStrokaChange;
app.findTextPreferences = NothingEnum.nothing;
app.changeTextPreferences = NothingEnum.nothing;
myStrokaFind = mySpace + myShortWord + mySpace;
app.findTextPreferences.findWhat = myStrokaFind;
myFound = myText.findText(); //собрана коллекция искомых элементов в статье.
if (myFound.length !=0) { //LQ
// цикл по числу элементов коллекции. Движение снизу вверх
    for (j=myFound.length-1; j >= 0; j--){ // NQ	
	myLine = myFound[j] ;
// вставляем эластичный неразрывный пробел вместо пробела
	myLine.characters.item(-1).contents  = myNonBreakableSpaceVariableWidth;
	} // NQ
 } //LQ
// эти слова могут встречаться и сразу после круглой скобки
app.findTextPreferences = NothingEnum.nothing;
app.changeTextPreferences = NothingEnum.nothing;
myStrokaFind = "(" + myShortWord + mySpace;
app.findTextPreferences.findWhat = myStrokaFind;
myFound = myText.findText(); //собрана коллекция искомых элементов в статье.
if (myFound.length !=0) { //LQ
// цикл по числу элементов коллекции. Движение снизу вверх
    for (j=myFound.length-1; j >= 0; j--){ // NQ	
	myLine = myFound[j] ;
// вставляем эластичный неразрывный пробел вместо пробела
	myLine.characters.item(-1).contents  = myNonBreakableSpaceVariableWidth;
	} // NQ
 } //LQ
// эти слова могут встречаться и сразу после открывающей кавычки
app.findTextPreferences = NothingEnum.nothing;
app.changeTextPreferences = NothingEnum.nothing;
myStrokaFind = "«" + myShortWord + mySpace;
app.findTextPreferences.findWhat = myStrokaFind;
myFound = myText.findText(); //собрана коллекция искомых элементов в статье.
if (myFound.length !=0) { //LQ
// цикл по числу элементов коллекции. Движение снизу вверх
    for (j=myFound.length-1; j >= 0; j--){ // NQ	
	myLine = myFound[j] ;
// вставляем эластичный неразрывный пробел вместо пробела
	myLine.characters.item(-1).contents  = myNonBreakableSpaceVariableWidth;
	} // NQ
 } //LQ
// эти слова могут встречаться и сразу неразрывного пробела
app.findTextPreferences = NothingEnum.nothing;
app.changeTextPreferences = NothingEnum.nothing;
myStrokaFind = myNonBreakableSpaceVariableWidth + myShortWord + mySpace;
app.findTextPreferences.findWhat = myStrokaFind;
myFound = myText.findText(); //собрана коллекция искомых элементов в статье.
if (myFound.length !=0) { //LQ
// цикл по числу элементов коллекции. Движение снизу вверх
    for (j=myFound.length-1; j >= 0; j--){ // NQ	
	myLine = myFound[j] ;
// вставляем эластичный неразрывный пробел вместо пробела
	myLine.characters.item(-1).contents  = myNonBreakableSpaceVariableWidth;
	} // NQ
 } //LQ
} //X
function myMinusBeforeDigit() { //YB // ищем пробел и тире (или дефис) перед цифрой и ставим перед цифрой минус
myRightMinus("-");   // дефис
myRightMinus(myNonbreakingHyphen);
myRightMinus("—"); // тире
}  //YB	
function myRightMinus(myChar) { //GP
app.findTextPreferences = NothingEnum.nothing;
app.changeTextPreferences = NothingEnum.nothing;
app.findTextPreferences.findWhat = mySpace + myChar + "^9";
myFound = myText.findText(); //собрана коллекция искомых элементов в статье.
if (myFound.length !=0) { //LQ@
// цикл по числу элементов коллекции. Движение снизу вверх
    for (j=myFound.length-1; j >= 0; j--){ // NQ@	
	myLine = myFound[j] ;
//заменяем символ, стоявший перед цифрой, на минус 
	myLine.characters.item(1).contents  = "–";
	} // NQ@
 } //LQ@	
}  //GP	
//
function myNobrkSpaceBeforeShortWord(myShortWord) { //X+
var myStrokaFind;
var myStrokaChange;
app.findTextPreferences = NothingEnum.nothing;
app.changeTextPreferences = NothingEnum.nothing;
myStrokaFind = mySpace + myShortWord;
app.findTextPreferences.findWhat = myStrokaFind;
myFound = myText.findText(); //собрана коллекция искомых элементов в статье.
if (myFound.length !=0) { //LQ+
// цикл по числу элементов коллекции. Движение снизу вверх
    for (j=myFound.length-1; j >= 0; j--){ // NQ+	
	myLine = myFound[j] ;
// вставляем эластичный неразрывный пробел вместо первого пробела
	myLine.characters.item(0).contents  = myNonBreakableSpaceVariableWidth;
	} // NQ+
 } //LQ
} //X+
//
function myCreateProgressPanel(myMaximumValue, myProgressBarWidth,myInfoProgressLine) {  //A
var myProgressPanel = new Window('window', myInfoProgressLine);
	with(myProgressPanel){
		myProgressPanel.myProgressBar = add('progressbar', [12, 12, myProgressBarWidth, 24], 0, myMaximumValue);
	}
return myProgressPanel;
} //A
//
function myStepByStep(myProgressPanel,myProgressIndex,myIncrement) { //FA
if (myDebug == true) 	
	{
		alert ("Очередной шаг обработки", myStepOfProcess);
		myStepOfProcess++;
		return;
	}
myProgressPanel.myProgressBar.value = myProgressIndex;
myProgressIndex++;
return myProgressIndex;
} //FA
function myMissedSpace(myChar) { //D
app.findTextPreferences = app.changeTextPreferences = NothingEnum.nothing;
app.findTextPreferences.findWhat = myChar + "^$"; // маска поиска
myFound = myText.findText(); //собрана коллекция искомых элементов в статье.
if (myFound.length !=0) { //L5
// цикл по числу элементов коллекции. Движение снизу вверх
    for (j=myFound.length-1; j >= 0; j--){ // N5	
	myLine = myFound[j] ;
// вставляем пробел после указанного знака
myLine.insertionPoints[-2].contents = mySpace;
	} //N5
} //L5
if (myChar == "—" ) { //U
	// в случае тире ищем случаи, когда тире идет сразу после буквы и при нахождении вставляем межу ними неразрывный гибкий пробел
	app.findTextPreferences.findWhat = "^$" + myChar; // маска поиска
	myFound = myText.findText(); //собрана коллекция искомых элементов в статье.
	if (myFound.length !=0) { //L*
	// цикл по числу элементов коллекции. Движение снизу вверх
		for (j=myFound.length-1; j >= 0; j--){ // N*	
		myLine = myFound[j] ;
		// вставляем неразрывный пробел перед тире
		myLine.insertionPoints[-2].contents = myNonBreakableSpaceVariableWidth;
		} //N*
	} //L*
} //U
} //D	
function myTornParagraph() { //ZS // в сносках оборванные абзацы не ищем. Пока...
for (var j = 0; j < myText.paragraphs.length; j++) { //QW
		var i = myText.paragraphs[j].length;
		if 	(myText.paragraphs[j].length >1) { //WE // Длина 1 только у одиночных знаков первода строки
		myLastCharInPara = myText.paragraphs[j].characters[-2].contents;  // считан последний символ абзаца
		if (myLastCharInPara == 1397518451) continue; // это нумератор для многоточия
		if (myLastCharInPara == 1397058884 ) continue; // это нумератор для тире
		//if (myText.paragraphs[j].characters[-2].fillColor.name == "myInfoColor") continue; // проверка на некорректный последний символ выполняется только для букв, цвет которых не менялся программой (т.е. это не заголовок, выделенный в исходном тексте полужирным или курсивом)		
		if (myText.paragraphs[j].characters[-2].fontStyle == "Bold" || myText.paragraphs[j].characters[-2].fontStyle == "Bold Italic" || myText.paragraphs[j].characters[-2].fontStyle == "Italic") continue; // проверка на некорректный последний символ выполняется только для букв, выделенных в исходном тексте полужирным или курсивом
		for (var k=0; k <  myRightChars.length; k++) { //OP
		if (myLastCharInPara != myRightChars [k]) continue;
		break; // встречен один из символов, котором должен кончаться абзац
		}  //OP
		if (k == myRightChars.length) { //YU  // последний символ абзаца не совпал ни с одним элементом массива myRightChars [ ]
				myBadParaFound++; 
				myText.paragraphs[j].insertionPoints[-2].contents = mySpace;	
				//break; 
			}  //YU
 	} //WE
} //QW
} //ZS	
function myV_V_G_G (myWordBad) { //QF
// разделитель -- обычный пробел
app.findTextPreferences = app.changeTextPreferences = NothingEnum.nothing;
app.findTextPreferences.findWhat = "^9" + " " + myWordBad; // маска поиска
mySurplusDot(); 
// разделитель -- неразрывный пробел
app.findTextPreferences = app.changeTextPreferences = NothingEnum.nothing;
app.findTextPreferences.findWhat = "^9" + myNonBreakableSpaceVariableWidth + myWordBad; // маска поиска
mySurplusDot();
// в случае сокращения в.в. предполагаем, что перед ним могут быть римские цифры
if (myWordBad =="в.в.") { //SW 
app.findTextPreferences = app.changeTextPreferences = NothingEnum.nothing;
app.findTextPreferences.findWhat = "I" + " " + myWordBad; // маска поиска
mySurplusDot();
app.findTextPreferences = app.changeTextPreferences = NothingEnum.nothing;
app.findTextPreferences.findWhat = "V" + " " + myWordBad; // маска поиска
mySurplusDot();
app.findTextPreferences = app.changeTextPreferences = NothingEnum.nothing;
app.findTextPreferences.findWhat = "X" + " " + myWordBad; // маска поиска (лат.)
app.findTextPreferences.findWhat = "Х" + " " + myWordBad; // маска поиска (рус.)
mySurplusDot(); 
// разделитель -- неразрывный пробел
app.findTextPreferences = app.changeTextPreferences = NothingEnum.nothing;
app.findTextPreferences.findWhat = "I" + myNonBreakableSpaceVariableWidth + myWordBad; // маска поиска
mySurplusDot();
app.findTextPreferences = app.changeTextPreferences = NothingEnum.nothing;
app.findTextPreferences.findWhat = "V" + myNonBreakableSpaceVariableWidth + myWordBad; // маска поиска
mySurplusDot();
app.findTextPreferences = app.changeTextPreferences = NothingEnum.nothing;
app.findTextPreferences.findWhat = "X" + myNonBreakableSpaceVariableWidth + myWordBad; // маска поиска (лат.)
app.findTextPreferences.findWhat = "Х" + myNonBreakableSpaceVariableWidth + myWordBad; // маска поиска  (рус.)
mySurplusDot();
} //SW
} //QF	
//
function mySurplusDot() { //GF
myFound = myText.findText(); //собрана коллекция искомых элементов в статье.
if (myFound.length !=0) { //L5F
// цикл по числу элементов коллекции. Движение снизу вверх
    for (j=myFound.length-1; j >= 0; j--){ // N5F	
	myLine = myFound[j] ;
// вставляем эластичный неразрывный пробел вместо пробела
myLine.characters.item(1).contents  = myNonBreakableSpaceVariableWidth;
// удаляем лишнюю точку
myLine.characters.itemByRange(3,3).remove();
	} //N5F
} //L5F
}  //GF
////////////////
function myAugment () { //myAugment
// Augment -- наращение. Ищем в тексте неправильные наращения, например, 5-ого, 14-ых, и исправляем их: 5-го, 14-х
// к моменту вызова этой процедуры обычный дефис после цифры уже заменен на неразрывный.
var mySearchedTwoCharacters = '(\\d[\u2011]ый[,.;:!?\\s]|\\d[\u2011]ой[,.;:!?\\s]|\\d[\u2011]ий[,.;:!?\\s]|\\d[\u2011]ым[,.;:!?\\s]|\\d[\u2011]им[,.;:!?\\s]|\\d[\u2011]ом[,.;:!?\\s]|\\d[\u2011]ем[,.;:!?\\s]|\\d[\u2011]ых[,.;:!?\\s]|\\d[\u2011]их[,.;:!?\\s]|\\d[\u2011]ые[,.;:!?\\s]|\\d[\u2011]ьи[,.;:!?\\s])';
var mySearchedThreeCharacters = '(\\d[\u2011]ого[,.;:!?\\s]|\\d[\u2011]его[,.;:!?\\s]|\\d[\u2011]ому[,.;:!?\\s]|\\d[\u2011]ему[,.;:!?\\s]|\\d[\u2011]ыми[,.;:!?\\s]|\\d[\u2011]ими[,.;:!?\\s])';

app.findGrepPreferences = NothingEnum.nothing;
app.findGrepPreferences.findWhat = mySearchedTwoCharacters;				
myFoundSamples = myText.findGrep();
if (myFoundSamples.length != 0) {
	try{ //4
		myColor = myDocument.colors.item("myModifiedChars");
		myName = myColor.name;
    }  //4
    catch (myError) { //3
		myColor = myDocument.colors.add ({name:"myModifiedChars", model:ColorModel.process, space:ColorSpace.CMYK, colorValue:myModifiedCharSample});
    } //3
// цикл по числу элементов коллекции. Движение снизу вверх
    for (j=myFoundSamples.length-1; j >= 0; j--) {	
		myLine = myFoundSamples[j] ;
		myLine.characters.itemByRange(2,2).remove();	// удаляем букву после дефиса
	}
}
app.findGrepPreferences = NothingEnum.nothing;
app.findGrepPreferences.findWhat = mySearchedThreeCharacters;				
myFoundSamples = myText.findGrep();
if (myFoundSamples.length != 0) {
	try{ //4
		myColor = myDocument.colors.item("myModifiedChars");
		myName = myColor.name;
    }  //4
    catch (myError) { //3
		myColor = myDocument.colors.add ({name:"myModifiedChars", model:ColorModel.process, space:ColorSpace.CMYK, colorValue:myModifiedCharSample});
    } //3
// цикл по числу элементов коллекции. Движение снизу вверх
    for (j=myFoundSamples.length-1; j >= 0; j--) {	
		myLine = myFoundSamples[j] ;
		myLine.characters.itemByRange(2,2).remove();	// удаляем букву после дефиса
	}
}
} //myAugment
///////////////
function mySetNoBreak(myCharForProc) { //QL
app.findTextPreferences = app.changeTextPreferences = NothingEnum.nothing;
app.findChangeTextOptions.includeFootnotes = true;
app.findTextPreferences.findWhat =myCharForProc; // маска поиска
myFound = myText.findText(); //собрана коллекция искомых элементов в статье
if (myFound.length !=0) { //L5F
	for (j=myFound.length-1; j >= 0; j--){ // N5~	
	myLine = myFound[j] ;
	var myInd = myLine.index;
	if (myCharForProc.length == 5 ) myInd++; // если обрабатывается сочетание цифра-минус-цифра, то индекс должен указывать на минус
	//myLine.parent.characters.itemByRange(myInd ,myInd).noBreak = true;
	myLine.parent.characters[myInd].noBreak = true;
	} //N5~
} //L5F
} //QL 
function myRightPhoneNote() { //UW
var myCountPhoneNumbers;	
var myCountProcessedPhoneNumbers;
if (myPhoneSample == mySample322) { //ON
app.findTextPreferences = app.changeTextPreferences = NothingEnum.nothing;
app.findTextPreferences.findWhat = "^9^9^9–^9^9–^9^9";
myCountPhoneNumbers = myText.findText().length; //узнали, сколько телефонов такого формата в верстке.
myCountProcessedPhoneNumbers = myPhoneMask322();
// условие ниже -- учет другой тонкой ошибки, сходной с описанной выше "Дж.". Если идут подряд несколько абзацев, в которых только телефонные номера, 
// то знак перевода строки, попавший в маску поиска  "^?^9^9^9–^9^9–^9^9^?", не будет уже в маске для очередного номера. В результате налицо потеря номеров.
// Случай редкий, для решения проблемы вначале определяется число семизначных телефонных номеров, потом сравнивается число обработанных номеров с этим.
// При неравенстве запускаем процедуру еще раз.
if (myCountPhoneNumbers > myCountProcessedPhoneNumbers) myPhoneMask322();
// поиск номеров телефонов, формат представления которых отличен от mySample322
app.findTextPreferences = app.changeTextPreferences = NothingEnum.nothing;
app.findTextPreferences.findWhat = "^9^9^9–^9^9^9^9";
myCountPhoneNumbers = myText.findText().length; //узнали, сколько телефонов такого формата в верстке.
myCountProcessedPhoneNumbers = myPhoneMask34Correct();
if (myCountPhoneNumbers > myCountProcessedPhoneNumbers) myPhoneMask34Correct();
} //ON 
//////////////////////////
if (myPhoneSample == mySample34) { //ON%
app.findTextPreferences = app.changeTextPreferences = NothingEnum.nothing;
app.findTextPreferences.findWhat = "^9^9^9–^9^9^9^9";
myCountPhoneNumbers = myText.findText().length; //узнали, сколько телефонов такого формата в верстке.
myCountProcessedPhoneNumbers = myPhoneMask34();
if (myCountPhoneNumbers > myCountProcessedPhoneNumbers) myPhoneMask34();
// поиск номеров телефонов, формат представления которых отличен от mySample34
app.findTextPreferences = app.changeTextPreferences = NothingEnum.nothing;
app.findTextPreferences.findWhat = "^9^9^9–^9^9–^9^9";
myCountPhoneNumbers = myText.findText().length; //узнали, сколько телефонов такого формата в верстке.
myCountProcessedPhoneNumbers = myPhoneMask322Correct();
if (myCountPhoneNumbers > myCountProcessedPhoneNumbers) myPhoneMask322Correct();
 } //ON%
} //UW
function myPhoneMask322() { //DV
var myCh0, myCh9, myCh10;
app.findTextPreferences = app.changeTextPreferences = NothingEnum.nothing;
app.findTextPreferences.findWhat = "^?^9^9^9–^9^9–^9^9^?";
myFound = myText.findText(); //собрана коллекция искомых элементов в статье.
for (j=myFound.length-1; j >= 0; j--) { // N5==	
	myLine = myFound[j] ;
	myCh0 = myLine.characters.item(0).contents;
	myCh10 = myLine.characters.item(10).contents;
	// перед номером стоит любой символ. Теоретически это может быть цифра, т.е. 1917-1924 не должны восприниматься как телефонный номер 917-1924, перед которым стоит 1
	if (myCh0 != mySpace && myCh0 != 1397124194 &&  myCh0 != myLineBreak)	{ //QO "myCh0 != 1397124194 &&  myCh0 != myLineBreak" -- учет редкой ситуации, когда номер -- это один абзац.
		if 	(Number(myCh0) >= Number("0") && Number(myCh0) <= Number("9")) { continue; }
	} //QO
	// аналогично, если последний знак в выборке -- цифра, то это не телефонный номер
	if (myCh10 != myLineBreak && myCh10 != myForcedLineBreak)	// если последний символ в выборке -- один из символов перевода строки, проверку на принадлежность цифрам не проводим
		if 	(Number(myCh10) >= Number("0") && Number(myCh10) <= Number("9")) { continue; }
	// после телефонного номера может идти запятая, точка с запятой, точка, пробел, принудительный перевод строки или возврат каретки. 
	//Другие символы -- признак, что это сочетание цифр только похоже на телеф. номер. (1397124194 -- нумератор кода myForcedLineBreak)
	if 	(myCh10 == "," || myCh10 == ";" ||  myCh10 == "." ||  myCh10 == " " ||  myCh10 == 1397124194 ||  myCh10 == myLineBreak )  { //QZ 
		myLine.characters.item(4).contents  = myPhoneDigitSeparator;
		myLine.characters.item(7).contents  = myPhoneDigitSeparator;
	if (myCh0 == 1397124194 ||  myCh0 == myLineBreak)  { continue; } // если номер телефона -- один абзац, пробел перед ним не ставим
	if 	(myCh0 != mySpace)
		myLine.insertionPoints[1].contents = myNonBreakableSpaceFixedWidth;  // вставим неразрывный пробел перед номером телефона
	else myLine.characters.item(0).contents = myNonBreakableSpaceFixedWidth; // заменяем обычный пробел перед номером телефона на неразрывный		
		} //QZ
	} //N5==
return (myFound.length);
} //DV
function myPhoneMask34Correct() { //NY
var myCh0, myCh9, myCh10;
app.findTextPreferences = app.changeTextPreferences = NothingEnum.nothing;
app.findTextPreferences.findWhat = "^?^9^9^9–^9^9^9^9^?";
myFound = myText.findText(); //собрана коллекция искомых элементов в статье.
for (j=myFound.length-1; j >= 0; j--){ // N5~~=	
	myLine = myFound[j] ;
	myCh0 = myLine.characters.item(0).contents;
	myCh9 = myLine.characters.item(9).contents;
	// перед номером стоит любой символ. Теоретически это может быть цифра, т.е. 1917-1924 не должны восприниматься как телефонный номер 917-1924, перед которым стоит 1
	if (myCh0 != mySpace && myCh0 != 1397124194 &&  myCh0 != myLineBreak)	{ //QO~~ "myCh0 != 1397124194 &&  myCh0 != myLineBreak" -- учет редкой ситуации, когда номер -- это один абзац.
		if 	(Number(myCh0) >= Number("0") && Number(myCh0) <= Number("9")) { continue; }
	} //QO~~
	// аналогично, если последний знак в выборке -- цифра, то это не телефонный номер
	if (myCh9 != myLineBreak && myCh9 != myForcedLineBreak)	// если последний символ в выборке -- один из символов перевода строки, проверку на принадлежность цифрам не проводим
		if 	(Number(myCh9) >= Number("0") && Number(myCh9) <= Number("9")) { continue; }
	// после телефонного номера может идти запятая, точка с запятой, точка, пробел, принудительный перевод строки или возврат каретки. 
	//Другие символы -- признак, что это сочетание цифр только похоже на телеф. номер. (1397124194 -- нумератор кода myForcedLineBreak)
	if 	(myCh9 == "," || myCh9 == ";" ||  myCh9 == "." ||  myCh9 == " " ||  myCh9 == 1397124194 ||  myCh9 == myLineBreak )  { //QZ~~~ 
		myLine.characters.item(4).contents  = myPhoneDigitSeparator;
		myLine.insertionPoints[7].contents = myPhoneDigitSeparator;	
	if (myCh0 == 1397124194 ||  myCh0 == myLineBreak)  { continue; } // если номер телефона -- один абзац, пробел перед ним не ставим
	if 	(myCh0 != mySpace)
		myLine.insertionPoints[1].contents = myNonBreakableSpaceFixedWidth; // вставим неразрывный пробел перед номером телефона
	else myLine.characters.item(0).contents = myNonBreakableSpaceFixedWidth; // заменяем обычный пробел перед номером телефона на неразрывный			
		} //QZ~~~
	} //N5~~=
return (myFound.length);
} //NY
function myPhoneMask34() {  //MU
var myCh0, myCh9, myCh10;
app.findTextPreferences = app.changeTextPreferences = NothingEnum.nothing;
app.findTextPreferences.findWhat = "^?^9^9^9–^9^9^9^9^?";
myFound = myText.findText(); //собрана коллекция искомых элементов в статье.
for (j=myFound.length-1; j >= 0; j--){ // N5~~=	
	myLine = myFound[j] ;
	myCh0 = myLine.characters.item(0).contents;
	myCh9 = myLine.characters.item(9).contents;
	// перед номером стоит любой символ. Теоретически это может быть цифра, т.е. 1917-1924 не должны восприниматься как телефонный номер 917-1924, перед которым стоит 1
	if (myCh0 != mySpace && myCh0 != 1397124194 &&  myCh0 != myLineBreak)	{ //QO~~ "myCh0 != 1397124194 &&  myCh0 != myLineBreak" -- учет редкой ситуации, когда номер -- это один абзац.
		if 	(Number(myCh0) >= Number("0") && Number(myCh0) <= Number("9")) { continue; }
	} //QO~~
	// аналогично, если последний знак в выборке -- цифра, то это не телефонный номер
	if (myCh9 != myLineBreak && myCh9 != myForcedLineBreak)	// если последний символ в выборке -- один из символов перевода строки, проверку на принадлежность цифрам не проводим
		if 	(Number(myCh9) >= Number("0") && Number(myCh9) <= Number("9")) { continue; }
	// после телефонного номера может идти запятая, точка с запятой, точка, пробел, принудительный перевод строки или возврат каретки. 
	//Другие символы -- признак, что это сочетание цифр только похоже на телеф. номер. (1397124194 -- нумератор кода myForcedLineBreak)
	if 	(myCh9 == "," || myCh9 == ";" ||  myCh9 == "." ||  myCh9 == " " ||  myCh9 == 1397124194 ||  myCh9 == myLineBreak )  { //QZ~~~ 
		myLine.characters.item(4).contents  = myPhoneDigitSeparator;
	if (myCh0 == 1397124194 ||  myCh0 == myLineBreak)  { continue; } // если номер телефона -- один абзац, пробел перед ним не ставим
	if 	(myCh0 != mySpace)
		myLine.insertionPoints[1].contents = myNonBreakableSpaceFixedWidth; // вставим неразрывный пробел перед номером телефона
	else myLine.characters.item(0).contents = myNonBreakableSpaceFixedWidth;  // заменяем обычный пробел перед номером телефона на неразрывный	
		} //QZ~~~
	} //N5~~=
return (myFound.length);
} //MU
function myPhoneMask322Correct() { //JU
var myCh0, myCh9, myCh10;
app.findTextPreferences = app.changeTextPreferences = NothingEnum.nothing;
app.findTextPreferences.findWhat = "^?^9^9^9–^9^9–^9^9^?";
myFound = myText.findText(); //собрана коллекция искомых элементов в статье.
for (j=myFound.length-1; j >= 0; j--){ // N5==	
	myLine = myFound[j] ;
	myCh0 = myLine.characters.item(0).contents;
	myCh10 = myLine.characters.item(10).contents;
	// перед номером стоит любой символ. Теоретически это может быть цифра, т.е. 1917-1924 не должны восприниматься как телефонный номер 917-1924, перед которым стоит 1
	if (myCh0 != mySpace && myCh0 != 1397124194 &&  myCh0 != myLineBreak)	{ //QO "myCh0 != 1397124194 &&  myCh0 != myLineBreak" -- учет редкой ситуации, когда номер -- это один абзац.
		if 	(Number(myCh0) >= Number("0") && Number(myCh0) <= Number("9")) { continue; }
	} //QO
	// аналогично, если последний знак в выборке -- цифра, то это не телефонный номер
	if (myCh10 != myLineBreak && myCh10 != myForcedLineBreak)	// если последний символ в выборке -- один из символов перевода строки, проверку на принадлежность цифрам не проводим
		if 	(Number(myCh10) >= Number("0") && Number(myCh10) <= Number("9")) { continue; }
	// после телефонного номера может идти запятая, точка с запятой, точка, пробел, принудительный перевод строки или возврат каретки. 
	//Другие символы -- признак, что это сочетание цифр только похоже на телеф. номер. (1397124194 -- нумератор кода myForcedLineBreak)
	if 	(myCh10 == "," || myCh10 == ";" ||  myCh10 == "." ||  myCh10 == " " ||  myCh10 == 1397124194 ||  myCh10 == myLineBreak )  { //QZ 
		myLine.characters.item(4).contents  = myPhoneDigitSeparator;
		myLine.characters.itemByRange(7,7).remove();
	if (myCh0 == 1397124194 ||  myCh0 == myLineBreak)  { continue; } // если номер телефона -- один абзац, пробел перед ним не ставим
	if 	(myCh0 != mySpace)
		myLine.insertionPoints[1].contents = myNonBreakableSpaceFixedWidth; // вставим неразрывный пробел перед номером телефона
	else myLine.characters.item(0).contents = myNonBreakableSpaceFixedWidth; // заменяем обычный пробел перед номером телефона	на неразрывный
		} //QZ
	} //N5==
return (myFound.length);
} //JU
function mySelectParametersDialog(myPath) { //TC
var myDialog = app.dialogs.add({name:myProgramTitul, canCancel:true});
with (myDialog.dialogColumns.add()) { //FG
with (dialogRows.add().borderPanels.add().dialogColumns.add()) { //HH
with (dialogRows.add()) { //LK
with(dialogColumns.add()) { //UY
		with (dialogColumns.add()) { //BY
			staticTexts.add({staticLabel:"Вариант используемого тире в тексте            "});
			var myVariantOfDash = radiobuttonGroups.add();
			with(myVariantOfDash) { //JC
				if (myVidTire == 0) { //MN
					var mySpDashSp = radiobuttonControls.add({staticLabel:"обычное тире — ", checkedState:true});
					var mySpMinusSp = radiobuttonControls.add({staticLabel:"короткое тире (минус) – "});
					} //MN
				else { //VF
					var mySpDashSp = radiobuttonControls.add({staticLabel:"обычное тире — "});
					var mySpMinusSp = radiobuttonControls.add({staticLabel:"короткое тире (минус) – ", checkedState:true});
					} //VF
			} //JC
		with (dialogColumns.add()) { //CE
			staticTexts.add({staticLabel:"Разделитель цифр в интервалах годов и чисел "});
			var myVariantOfDigSep = radiobuttonGroups.add();
					with(myVariantOfDigSep) { //JC
						if (mySepInYears == 0) { //NU
							var myDigMinusfSp = radiobuttonControls.add({staticLabel:"минус", checkedState:true});
							var myDigDefSp = radiobuttonControls.add({staticLabel:"тире"});
							} //NU
					else  { //NW
							var myDigMinusfSp = radiobuttonControls.add({staticLabel:"минус"});
							var myDigDefSp = radiobuttonControls.add({staticLabel:"тире", checkedState:true});
							} //NW
				} //JC
			} //CE
		} //BY
	} //UY
} //LK
dialogRows.add().staticTexts.add({staticLabel: ""});	//строка для отбивки информационных блоков
with (dialogRows.add()) { //LK
with(dialogColumns.add()) { //UY
		with (dialogColumns.add()) { //BY
			staticTexts.add({staticLabel:"Вариант сокращений — с точкой или без точки          "});
			var myVariantOfBigValue = radiobuttonGroups.add();
			with(myVariantOfBigValue) { //JC
				if (myDotOrNot == 0) { //FR
					var myBigValueWithPoint = radiobuttonControls.add({staticLabel:"млн., млрд., трлн.", checkedState:true});
					var myBigValueWOPoint = radiobuttonControls.add({staticLabel:"млн, млрд, трлн"});
					} //FR
				else  { //FB
					var myBigValueWithPoint = radiobuttonControls.add({staticLabel:"млн., млрд., трлн."});
					var myBigValueWOPoint = radiobuttonControls.add({staticLabel:"млн, млрд, трлн", checkedState:true});
					} //FB
			} //JC
		dialogRows.add().staticTexts.add({staticLabel: " "});	//строка для отбивки информационных блоков
		with (dialogColumns.add()) { //CE
			staticTexts.add({staticLabel:"Оформление знаков процента и промилле"});
			var myVariantOfProc = radiobuttonGroups.add();
					with(myVariantOfProc) { //JC
						if (myProcMille == 0) { //BU
							var myProcSignOnly = radiobuttonControls.add({staticLabel:"без отбивки от числа", checkedState:true});
							var myProcSignAndSpace = radiobuttonControls.add({staticLabel:"отбиваются от числа тонкой шпацией"});
							} //BU
						else { //BZ
							var myProcSignOnly = radiobuttonControls.add({staticLabel:"без отбивки от числа"});
							var myProcSignAndSpace = radiobuttonControls.add({staticLabel:"отбиваются от числа тонкой шпацией", checkedState:true});
							} //BZ
				} //JC
			} //CE
		} //BY
	} //UY
} //LK
if (myRepEntSel == 0) { //NP
	var myRepeatedEnterSelection = checkboxControls.add({staticLabel:"Удалить повторяющиеся символы перевода строки", checkedState:true})
} //NP
else { //AU
	var myRepeatedEnterSelection = checkboxControls.add({staticLabel:"Удалить повторяющиеся символы перевода строки", checkedState:false})
} //AU
if (myTabRemove == 1) {
	var myTR = checkboxControls.add({staticLabel:"Заменить символы табуляции на пробелы", checkedState:true})
} 
else { 
	var  myTR = checkboxControls.add({staticLabel:"Удалить символы табуляции", checkedState:false})
} 
if (myHyphenationCharsRemove == 1) {
	var myHCR = checkboxControls.add({staticLabel:"Удалить в тексте символы переносов", checkedState:true})
} 
else { 
	var  myHCR = checkboxControls.add({staticLabel:"Удалить в тексте символы переносов", checkedState:false})
}
if (myListsRemove == 1) {
	var myLR = checkboxControls.add({staticLabel:"Преобразовать буллиты и нумерацию в текст", checkedState:true})
} 
else { 
	var  myLR = checkboxControls.add({staticLabel:"Преобразовать буллиты и нумерацию в текст", checkedState:false})
}
if (myHyperlinksRemove == 1) {
	var myHR = checkboxControls.add({staticLabel:"Удалить гиперссылки из текста", checkedState:true})
} 
else { 
	var  myHR = checkboxControls.add({staticLabel:"Удалить гиперссылки из текста", checkedState:false})
}
if (myVarPredlogs == 0) { //VS
	var myForbidOneTwoLetterWords = checkboxControls.add({staticLabel:"Запретить отрывать одно- и двухбуквенные предлоги (частицы, союзы) от слов, к которым они относятся", checkedState:true})
} //VS
else { //VZ
	var myForbidOneTwoLetterWords = checkboxControls.add({staticLabel:"Запретить отрывать одно- и двухбуквенные предлоги (частицы, союзы) от слов, к которым они относятся", checkedState:false})
} //VZ
if (myMakeIndexStyle == 0) { //VJ
	var myInfoAboutInTextSelection = checkboxControls.add({staticLabel:"Создать символьные стили для курсива, полужирного, верхнего и нижнего индексов", checkedState:false})
} //VJ
else { //VK
	var myInfoAboutInTextSelection = checkboxControls.add({staticLabel:"Создать символьные стили для курсива, полужирного, верхнего и нижнего индексов", checkedState:true})
} //VK
if (myAugmentSelection == 0) {
	var myAS = checkboxControls.add({staticLabel:"Привести в порядок наращение чисел (исправить '1-ых' на '1-x', '2-ого' на '2-го' и т.п.)", checkedState:false})
} 
else { 
	var myAS = checkboxControls.add({staticLabel:"Привести в порядок наращение чисел (исправить '1-ых' на '1-x', '2-ого' на '2-го' и т.п.)", checkedState:true})
}
if (mySetRussLangSelection == 1) { //RR
	var mySL = checkboxControls.add({staticLabel:"Присвоить тексту после обработки атрибут \"Русский язык\" ", checkedState:true})
} //RR
else { //rr
	var mySL = checkboxControls.add({staticLabel:"Присвоить тексту после обработки атрибут \"Русский язык\" ", checkedState:false})
} //rr
} //HH
//var myInfoPhoneProcessing = checkboxControls.add({staticLabel:"  Искать в тексте номера телефонов ", checkedState:false})
//var useOpt = dialogRows.add().enablingGroups.add({staticLabel: "Искать в тексте номера телефонов   "});
if (mySemiDigitNumber == 0) { //CR
	var myInfoPhoneProcessing = dialogRows.add().enablingGroups.add({staticLabel: "Искать в тексте семизначные номера телефонов   ", checkedState:true});
	} //CR
else { //CH
	var myInfoPhoneProcessing = dialogRows.add().enablingGroups.add({staticLabel: "Искать в тексте семизначные номера телефонов   ", checkedState:false});
	} //CH	
with (myInfoPhoneProcessing) { //MR
with (dialogColumns.add()) { //FZ
	with (dialogColumns.add()) { //KO
		dialogRows.add().staticTexts.add({staticLabel: " "});	//строка для отбивки информационных блоков		
		staticTexts.add({staticLabel:"Формат записи телефонного номера                                  "});
			var myVariantPhoneNumber = radiobuttonGroups.add();
			with(myVariantPhoneNumber){  //NW
				if (mySelectedVarPhoneNumber == 0) { //CE
					var my322 = radiobuttonControls.add({staticLabel:"000-00-00", checkedState:true});
					var my34 = radiobuttonControls.add({staticLabel:"000-0000"});
					} //CE
				else { //CV
					var my322 = radiobuttonControls.add({staticLabel:"000-00-00"});
					var my34 = radiobuttonControls.add({staticLabel:"000-0000", checkedState:true});
					} //CV
			} //NW
	with (dialogColumns.add()) { //NP	
		dialogRows.add().staticTexts.add({staticLabel: " "});	//строка для отбивки информационных блоков				
		staticTexts.add({staticLabel:"Разделитель цифр в телефонном номере         "});
			var myVariantDigitSeparator = radiobuttonGroups.add();
			with(myVariantDigitSeparator){  //FR
				if (mySelectedVarDigSeparator == 0) { //HY
					var mySepIsDefis = radiobuttonControls.add({staticLabel:"дефис                           ", checkedState:true});
					var mySepIsSpace = radiobuttonControls.add({staticLabel:"пробел                          "});
				 }//HY
			 	else { //HY
					var mySepIsDefis = radiobuttonControls.add({staticLabel:"дефис                           "});
					var mySepIsSpace = radiobuttonControls.add({staticLabel:"пробел                          ", checkedState:true});
				 }//HY
			} //FR
			} //NP
		} //KO
    } //FZ
  }  //MR
} //FG
if(myDialog.show() == false) { //cancel
	myDialog.destroy();
	exit(); 
} //cancel  
else { // DialogShow
	if (myVariantOfDash.selectedButton == 1) {myDashSeparator = mySpaceMinusSpace; myVidTire = 1;} else {myDashSeparator = mySpaceDashSpace; myVidTire = 0;}
	if (myVariantOfDigSep.selectedButton == 1) {myInterDigitSeparator = myInterDigitTire; mySepInYears = 1;} else {myInterDigitSeparator = myInterDigitMinus; mySepInYears = 0;}
	if (myVariantPhoneNumber.selectedButton == 1) {myPhoneSample = mySample34; mySelectedVarPhoneNumber = 1;} else {myPhoneSample = mySample322; mySelectedVarPhoneNumber = 0;}
	if (myVariantDigitSeparator.selectedButton == 1) {myPhoneDigitSeparator = mySeparatorIsSpace; mySelectedVarDigSeparator = 1;} else  {myPhoneDigitSeparator = mySeparatorIsDefis; mySelectedVarDigSeparator = 0;}
	if (myVariantOfBigValue.selectedButton == 1) {myBigValueView = myViewEmpty; myDotOrNot = 1;} else {myBigValueView = myViewWithPoint; myDotOrNot = 0;}
	if (myVariantOfProc.selectedButton == 1) {myViewProc = myProcAndSpace; myProcMille = 1;} else {myViewProc = myProcOnly; myProcMille = 0;}
	if (myInfoPhoneProcessing.checkedState == false)  { myPhoneProcessing = false; mySemiDigitNumber = 1;} else { myPhoneProcessing = true; mySemiDigitNumber = 0;}
	if (myRepeatedEnterSelection.checkedState == false) { myDeleteRepeatedEnter = false; myRepEntSel = 1;} else { myDeleteRepeatedEnter = true; myRepEntSel = 0;}
	if (myTR.checkedState == false) { myTabRemove = 0;} else { myTabRemove = 1;}	
	if (myHCR.checkedState == false) { myHyphenationCharsRemove = 0;} else { myHyphenationCharsRemove = 1;}	
	if (myLR.checkedState == false) { myListsRemove = 0;} else { myListsRemove = 1;}
	if (myHR.checkedState == false) { myHyperlinksRemove = 0;} else { myHyperlinksRemove = 1;}	
	if (myForbidOneTwoLetterWords.checkedState == false) { myForbidShortWords  = false; myVarPredlogs = 1;} else  { myForbidShortWords  = true; myVarPredlogs = 0;}
	if (myInfoAboutInTextSelection.checkedState == true) { mySelectionOn = 1; myMakeIndexStyle =1; } else { mySelectionOn = 0; myMakeIndexStyle =0; }
	if (myAS.checkedState == true) { myAugmentSelection = 1; } else { myAugmentSelection = 0; }
	if (mySL.checkedState == true) { mySetRussLangSelection = 1; } else { mySetRussLangSelection = 0; }
} // DialogShow
myDialog.destroy();
} //TC
function myUpperCaseLetterIs(myChar) { // KO
// конечно, надо бы разобраться в regexp и избавиться от этой функции	
var myCapLetterArray = ["К","Е","Н","Г","Ш","Щ","З","Х","В","А","П","Р","О","Л","Д","Ж","Э","Я","Ч","С","М","И","Т","Б","Ю","Й","Ц","У","Ф","Ы","Ъ","Ь", "Q", "W", "E", "R", "T", "Y", "U", "I", "O", "P", "A", "S", "D", "F", "G", "H", "J", "K", "L", "Z", "X", "C", "V", "B", "N", "M"];
for (i=0; i< myCapLetterArray.length; i++) { //FR
	if (myChar ==  myCapLetterArray [i]) return(true);
	} //FR
return(false);
} // KO
//////////////////
function myDigitAndLetter() { //myDigitAndLetter
var myDayAndMounthOrYear = '(\\d[ян|ЯН]|\\d[фев|ФЕВ|фвр|ФВР]|\\d[мар|МАР|мрт|МРТ]|\\d[апр|АПР]|\\d[ма|МА]|\\d[июн|ИЮН]|\\d[июл|ИЮЛ]|\\d[авг|АВГ]|\\d[сен|СЕН|снт|СНТ]|\\d[окт|ОКТ]|\\d[ноя|НОЯ|нбр|НБР]|\\d[дек|ДЕК]|\\d[г.|Г.|гг.|ГГ.])';	
app.findGrepPreferences = NothingEnum.nothing;
app.findGrepPreferences.findWhat = myDayAndMounthOrYear;				
myFoundSamples = myText.findGrep();
if (myFoundSamples.length != 0) {
	try{ //4
		myColor = myDocument.colors.item("myModifiedChars");
		myName = myColor.name;
    }  //4
    catch (myError) { //3
		myColor = myDocument.colors.add ({name:"myModifiedChars", model:ColorModel.process, space:ColorSpace.CMYK, colorValue:myModifiedCharSample});
    } //3
// цикл по числу элементов коллекции. Движение снизу вверх
    for (j=myFoundSamples.length-1; j >= 0; j--) {	
		myLine = myFoundSamples[j];
		myLine.fillColor = "myModifiedChars"; // на случай поиска этих символов покрасим их
		myLine.insertionPoints[1].contents = myNonBreakableSpaceVariableWidth; // вставляем между цифрой и буквой пробел
	}
}
} //myDigitAndLetter
////////////////
function myMlnMlrd(myWord) { //FP 
// для единообразия удалим точки в млн. и млрд. При этом:
// 1) Если после точки знак перевода строки, т.е. начало навого абзаца, точка не снимается.
// 2) Если после точки после пробела / теоретическивозможен вопросит. или восклицат. знак или закрывающая кавычка / прописная буква, 
// считаем, что эта точка -- конец предложения и оставляем её.
var myWordLength = myWord.length;
app.findTextPreferences = app.changeTextPreferences = NothingEnum.nothing;
app.findTextPreferences.findWhat = myWord + "."  + "^?^?^?";
myFound = myText.findText(); //собрана коллекция искомых элементов в статье.
if (myFound.length !=0) { //L5--
// цикл по числу элементов коллекции. Движение снизу вверх
    for (j=myFound.length-1; j >= 0; j--){ // N5--	
	myLine = myFound[j] ;
	var myCh1 = myLine.characters.item(myWordLength+1).contents;
	var myCh2 = myLine.characters.item(myWordLength+2).contents;
	var myCh3 = myLine.characters.item(myWordLength+3).contents;
	if (myCh1 == "\r")  { continue; } // Точку удалять нельзя, т.к. это конец абзаца
	if (myUpperCaseLetterIs (myCh2) == true || myUpperCaseLetterIs (myCh3) == true)  { continue; } // встречена прописная буква
	// удаляем лишнюю точку
	myLine.characters.itemByRange(myWordLength,myWordLength).remove();	
	} // N5--
} //L5--
// восстановим точки, если они нужны
if (myBigValueView == myViewWithPoint) { //IZ
	app.findTextPreferences = app.changeTextPreferences = NothingEnum.nothing;
	app.findTextPreferences.findWhat = myWord + "^?";
	 myFound = myText.findText();
	 if (myFound.length !=0) { //L5^
		for (j=myFound.length-1; j >= 0; j--){ // N5--	
		myLine = myFound[j] ;
		var myCh0 = myLine.characters.item(myWordLength).contents;
		if (myCh0 == ".")  { continue; } // эта точка нужна
		// вставляем точку после слова
		myLine.insertionPoints[myWordLength].contents = ".";	
		} // N5^
	} //L5^
} //IZ
} //FP
function myBoldItalicAndIndexSelection() {  // mySelectionOn=1
// выделение цветом текста в нижном и верхнем регистре (каждое начертание будет иметь свой символьный стиль)
// Заменяем верхний индекс форматирование символов на символьный стиль "Superscript" 
app.findTextPreferences = app.changeTextPreferences = NothingEnum.nothing;
app.findTextPreferences. position = Position.SUPERSCRIPT; // маска поиска
myFound = myText.findText(); //собрана коллекция искомых элементов в статье.
if (myFound.length !=0) { //L5
// цикл по числу элементов коллекции. Движение снизу вверх
    myStyledText++;
	try{ //4
	 myColor = myDocument.colors.item("myInfoColor");
	 myName = myColor.name;
    }  //4
    catch (myError) { //3
	 myColor = myDocument.colors.add ({name:"myInfoColor", model:ColorModel.process, space:ColorSpace.CMYK,  colorValue:myInfoColorSample});
    } //3	
	try{
	myDocument.characterStyles.item("mySupChars").name;
	}
	catch (myError){
	myDocument.characterStyles.add({name:"mySupChars"});
	}
	myDocument.characterStyles.item("mySupChars").fillColor = "myInfoColor";
	myDocument.characterStyles.item("mySupChars").position = Position.SUPERSCRIPT;
	myDocument.characterStyles.item("mySupChars").fontStyle = "Regular";
	for (j=myFound.length-1; j >= 0; j--){ // N5	
	myLine = myFound[j] ;
	myLine.appliedCharacterStyle = myDocument.characterStyles.item("mySupChars");
	} //N5
} //L5
//myStepByStep(myProgressPanel,myProgressIndex,myIncrement);
// Заменяем верхний индекс форматирование символов на символьный стиль "Subrscript" 
app.findTextPreferences = app.changeTextPreferences = NothingEnum.nothing;
app.findTextPreferences. position = Position.SUBSCRIPT; // маска поиска
myFound = myText.findText(); //собрана коллекция искомых элементов в статье.
if (myFound.length !=0) { //L5
// цикл по числу элементов коллекции. Движение снизу вверх
    myStyledText++;
	try{ //4
	 myColor = myDocument.colors.item("myInfoColor");
	 myName = myColor.name;
    }  //4
    catch (myError) { //3
	 myColor = myDocument.colors.add ({name:"myInfoColor", model:ColorModel.process, space:ColorSpace.CMYK,  colorValue:myInfoColorSample});
    } //3	
	try{
	myDocument.characterStyles.item("mySubChars").name;
	}
	catch (myError){
	myDocument.characterStyles.add({name:"mySubChars"});
	}
	myDocument.characterStyles.item("mySubChars").fillColor = "myInfoColor";
	myDocument.characterStyles.item("mySubChars").position = Position.SUBSCRIPT;
	myDocument.characterStyles.item("mySubChars").fontStyle = "Regular";
	for (j=myFound.length-1; j >= 0; j--){ // N5	
	myLine = myFound[j] ;
	myLine.appliedCharacterStyle = myDocument.characterStyles.item("mySubChars");
	} //N5
} //L5
//
app.findTextPreferences = app.changeTextPreferences = NothingEnum.nothing;
app.findTextPreferences. fontStyle = "Bold"; // маска поиска
myFound = myText.findText(); //собрана коллекция искомых элементов в статье.
if (myFound.length !=0) { //L5
// цикл по числу элементов коллекции. Движение снизу вверх
    myStyledText++;
	try{ //4
	 myColor = myDocument.colors.item("myInfoColor");
	 myName = myColor.name;
    }  //4
    catch (myError) { //3
	 myColor = myDocument.colors.add ({name:"myInfoColor", model:ColorModel.process, space:ColorSpace.CMYK,  colorValue:myInfoColorSample});
    } //3	
	try{
	myDocument.characterStyles.item("myBoldChars").name;
	}
	catch (myError){
	myDocument.characterStyles.add({name:"myBoldChars"});
	}
	myDocument.characterStyles.item("myBoldChars").fillColor = "myInfoColor";
	for (j=myFound.length-1; j >= 0; j--){ // N5	
	myLine = myFound[j] ;
	myLine.appliedCharacterStyle = myDocument.characterStyles.item("myBoldChars");	
	//myLine.fillColor  = "myBold";	
	} //N5
} //L5
// 
//myStepByStep(myProgressPanel,myProgressIndex,myIncrement);
app.findTextPreferences = app.changeTextPreferences = NothingEnum.nothing;
app.findTextPreferences.fontStyle = "Italic"; // маска поиска
myFound = myText.findText(); //собрана коллекция искомых элементов в статье.
if (myFound.length !=0) { //L5
// цикл по числу элементов коллекции. Движение снизу вверх
    myStyledText++;
	try{ //4
	 myColor = myDocument.colors.item("myInfoColor");
	 myName = myColor.name;
    }  //4
    catch (myError) { //3
	 myColor = myDocument.colors.add ({name:"myInfoColor", model:ColorModel.process, space:ColorSpace.CMYK,  colorValue:myInfoColorSample});
    } //3	
	try{
	myDocument.characterStyles.item("myItalicChars").name;
	}
	catch (myError){
	myDocument.characterStyles.add({name:"myItalicChars"});
	}
myDocument.characterStyles.item("myItalicChars").fillColor = "myInfoColor";
	for (j=myFound.length-1; j >= 0; j--){ // N5	
	myLine = myFound[j] ;
	if (myLine.appliedCharacterStyle.name == "myAccent") continue;
	myLine.appliedCharacterStyle = myDocument.characterStyles.item("myItalicChars");
	//myLine.fillColor  = "myItalic";	
	} //N5
} //L5
// 
//myStepByStep(myProgressPanel,myProgressIndex,myIncrement);
app.findTextPreferences = app.changeTextPreferences = NothingEnum.nothing;
app.findTextPreferences. fontStyle = "Bold Italic"; // маска поиска
myFound = myText.findText(); //собрана коллекция искомых элементов в статье.
if (myFound.length !=0) { //L5
// цикл по числу элементов коллекции. Движение снизу вверх
    myStyledText++;
	try{ //4
	 myColor = myDocument.colors.item("myInfoColor");
	 myName = myColor.name;
    }  //4
    catch (myError) { //3
	 myColor = myDocument.colors.add ({name:"myInfoColor", model:ColorModel.process, space:ColorSpace.CMYK,  colorValue:myInfoColorSample});
    } //3	
	try{
	myDocument.characterStyles.item("myBoldItalicChars").name;
	}
	catch (myError){
	myDocument.characterStyles.add({name:"myBoldItalicChars"});
	}
	myDocument.characterStyles.item("myBoldItalicChars").fillColor = "myInfoColor";
	for (j=myFound.length-1; j >= 0; j--){ // N5	
	myLine = myFound[j] ;
	myLine.appliedCharacterStyle = myDocument.characterStyles.item("myBoldItalicChars");
	//myLine.fillColor  = "myBoldItalic";	
	} //N5
} //L5
//myStepByStep(myProgressPanel,myProgressIndex,myIncrement);
} // mySelectionOn=1
function mySpaceDotsSpace() { //PM
app.findTextPreferences = app.changeTextPreferences = NothingEnum.nothing;
app.findTextPreferences.findWhat = " … ^?"; // ищем пробел многоточие пробел любой знак
myFound = myText.findText(); //собрана коллекция искомых элементов в статье.
for (j=myFound.length-1; j >= 0; j--){ // N5##	
	myLine = myFound[j];
	if ( myUpperCaseLetterIs ( myLine.characters.item(3).contents ) == false) continue; // любой знак в маске поиска -- не прописная буква
	myLine.characters.itemByRange(2,2).remove(); // удаляем пробел между многоточием и прописной буквой
	}  // N5##
} //PM	
function myFootnoteSignCorection () { //NI
app.findTextPreferences = app.changeTextPreferences = NothingEnum.nothing;
app.findTextPreferences.findWhat = "^9" +myNonBreakableSpaceVariableWidth;
myFound = myText.findText(); //собрана коллекция искомых элементов в статье.
for (j=myFound.length-1; j >= 0; j--){ // N5##	
	myLine = myFound[j];
	if ( myLine.characters.item(0).position != Position.SUPERSCRIPT )  continue; // цифра -- не знак сноски, значит, неразрывный пробел уместен
	// вставляем обычный пробел вместо неразрывного
	myLine.characters.item(1).contents  = mySpace;
	}  // N5##
//  
// если есть пробелы в верхнем регистре, делаем их нормальными.
app.findTextPreferences = app.changeTextPreferences = NothingEnum.nothing;
app.findTextPreferences. position = Position.SUPERSCRIPT; // маска поиска
app.findTextPreferences.findWhat = mySpace;
myFound = myText.findText(); //собрана коллекция искомых элементов в статье.
if (myFound.length !=0) { //L5*
	for (j=myFound.length-1; j >= 0; j--) {  // N5&&	
	myLine = myFound[j];
	myLine.characters.item(0).position = Position.NORMAL;
	} // N5&&	
} //L5* 
// обработка знаков сносок в случае файла с обычными, не концевыми сносками
for (i = myText.footnotes.length; i>0; i--) { //JB
	var myTmpIndx = myText.footnotes[i-1].storyOffset.index;
	myText.insertionPoints[myTmpIndx].contents = myThinSpace;
	myText.characters.item(myTmpIndx).position = Position.SUPERSCRIPT;
	} //JB
//
app.findTextPreferences = app.changeTextPreferences = NothingEnum.nothing;
app.findTextPreferences.findWhat = "^?^9";
myFound = myText.findText(); //собрана коллекция искомых элементов в статье.
for (j=myFound.length-1; j >= 0; j--){ // N5##	
	myLine = myFound[j];
	//var myCh = myLine.characters.item(0).contents;
// второй символ  -- не знак сноски, продолжаем поиск. Если первый символ — знак сноски, значит, выбраны два знака в самой сноске.	
	if (myLine.characters.item(0).position == Position.SUPERSCRIPT || myLine.characters.item(1).position != Position.SUPERSCRIPT )  continue;
	// вставляем тонкую шпацию перед сноской
	myLine.insertionPoints[-2].contents = myThinSpace;
	myLine.characters.item(1).position = Position.SUPERSCRIPT;
	if (myLine.characters.item(0).contents == mySpace) myLine.characters.itemByRange(0,0).remove(); // удаляем пробел
	}  // N5##
} //NI
function myPayAttention (myStrangeLine) {  //BY
app.findTextPreferences = app.changeTextPreferences = NothingEnum.nothing;
app.findTextPreferences.findWhat = myStrangeLine ; // маска поиска
myFound = myText.findText(); //собрана коллекция искомых элементов в статье.
if (myFound.length != 0) { //L5#
	myStrangePunctuation++;
// цикл по числу элементов коллекции. Движение снизу вверх
    try{ //4
	 myColor = myDocument.colors.item("myInfoColor");
	 myName = myColor.name;
    }  //4
    catch (myError) { //3
	 myColor = myDocument.colors.add ({name:"myInfoColor", model:ColorModel.process, space:ColorSpace.CMYK,  colorValue:myInfoColorSample});
    } //3	
	try{
	myDocument.characterStyles.item("myPayAttention").name;
	}
	catch (myError){
	myDocument.characterStyles.add({name:"myPayAttention"});
	}
	myDocument.characterStyles.item("myPayAttention").fillColor = "myInfoColor";
	for (j=myFound.length-1; j >= 0; j--){ // N5	
	myLine = myFound[j] ;
	myLine.appliedCharacterStyle = myDocument.characterStyles.item("myPayAttention");
 }  // N5#
} //L5#
} //BY
function myWordDotDigit(myWord) { // TR  //  если после этого слова идет точка и сразу цифра, то перед цифрой ставим неразрывный пробел
app.findTextPreferences = app.changeTextPreferences = NothingEnum.nothing;
app.findTextPreferences.findWhat =myWord +"." + "^9";
myFound = myText.findText(); //собрана коллекция искомых элементов в статье.
for (j=myFound.length-1; j >= 0; j--){ // N5##	
	myLine = myFound[j];
	myLine.insertionPoints[-2].contents = myNonBreakableSpaceVariableWidth ;
	}  // N5##
}// TR 
//
function mySetNoBreakStyle() { //QL
app.findTextPreferences = app.changeTextPreferences = NothingEnum.nothing;
app.findTextPreferences.noBreak = true; // маска поиска
myFound = myText.findText(); //собрана коллекция искомых элементов в статье.
/* if (myFound.length !=0) { //L5F
	try{ //4~
	 myColor = myDocument.colors.item("myInfoColor");
	 myName = myColor.name;
    }  //4~
    catch (myError) { //3~
	 myColor = myDocument.colors.add ({name:"myInfoColor", model:ColorModel.process, space:ColorSpace.CMYK, colorValue:myInfoColorSample});
    } //3~  */
try{
	myDocument.characterStyles.item("myNoBreakChars").name;
	}
	catch (myError){
	myDocument.characterStyles.add({name:"myNoBreakChars"});
	}
	//myDocument.characterStyles.item("myNoBreakChars").fillColor = "myInfoColor";
	myDocument.characterStyles.item("myNoBreakChars").noBreak = true;
	for (j=myFound.length-1; j >= 0; j--){ // N5~	
	myLine = myFound[j] ;
	if (myLine.appliedCharacterStyle.name == "mySupChars") continue; // если буквы в верхнем индексе, то после переопределения стиля символов пропадет символ в верхнем регистре
	myLine.appliedCharacterStyle = myDocument.characterStyles.item("myNoBreakChars");
	} //N5~
//} //L5F
} //QL
function myRimDigitInterval() { //LO //  дефис, минус или тире между римскими цифрами — заменяем на минус или тире, в зависимости от значения myInterDigitSeparator
var myChr0;
var myChr1;
app.findTextPreferences = app.changeTextPreferences = NothingEnum.nothing;
app.findTextPreferences.findWhat = "^$-^$"; // разделитель дефис
myFound = myText.findText(); //собрана коллекция искомых элементов в статье.
for (j=myFound.length-1; j >= 0; j--){ // N5~	
myLine = myFound[j] ;
myChr0 = myLine.characters.firstItem().contents;
myChr1 = myLine.characters.lastItem().contents;
if ((myRImLetterIs (myChr0) == true) && (myRImLetterIs (myChr1) == true)) { // DE
	myLine.characters.item(1).contents  = "–";   // минус
	 } // DE
	} //N5~
app.findTextPreferences = app.changeTextPreferences = NothingEnum.nothing;
app.findTextPreferences.findWhat = "^$" + myNonBreakableSpaceFixedWidth +"— ^$"; // разделители между символами — неразрывный пробел фиксированной ширины, тире и пробел
myFound = myText.findText(); //собрана коллекция искомых элементов в статье.
for (j=myFound.length-1; j >= 0; j--){ // N5~	
myLine = myFound[j] ;
myChr0 = myLine.characters.firstItem().contents;
myChr1 = myLine.characters.lastItem().contents;
if ((myRImLetterIs (myChr0) == true) && (myRImLetterIs (myChr1) == true)) { // DE
	myLine.characters.itemByRange(1,3).contents  = "–";  // минус
	 } // DE
	} //N5~
} //LO
function myRImLetterIs(myChar) { // KO
// конечно, надо бы разобраться в regexp и избавиться от этой функции	
var myCapLetterArray = ["I","V","X","C","L","M","Х","С","М"]; // три последние буквы — русские, совпадающие по написанию с латинскими 
for (i=0; i< myCapLetterArray.length; i++) { //FR
	if (myChar ==  myCapLetterArray [i]) return(true);
	} //FR
return(false);
} // KO
function myLastLetterOfSentenceFootnoteCorrection(myFourChar) { //PN // г. + MySpace (myNonBreakableSpaceVariableWidth) + myThinSpace
app.findTextPreferences = app.changeTextPreferences = NothingEnum.nothing;
app.findTextPreferences.findWhat = myFourChar;
myFound = myText.findText(); //собрана коллекция искомых элементов в статье.
for (j=myFound.length-1; j >= 0; j--){ // N5~	
	myLine = myFound[j] ;
	myLine.characters.itemByRange(2,2).remove();
  } //N5~
} //PN
function myList(myWord) { //OD
app.findTextPreferences = app.changeTextPreferences = NothingEnum.nothing;
app.findTextPreferences.findWhat = myWord;
myFound = myText.findText(); //собрана коллекция искомых элементов в статье.
for (j=myFound.length-1; j >= 0; j--){ // N5@@~	
	myLine = myFound[j] ;
	myLine.characters.item(-1).contents  = myNonBreakableSpaceFixedWidth; 
	} //N5@@~
} //OD
//*****************
// для обработки выделенного текста часть программы, выполняющая подготовку текста к верстке, выделена в отдельный исполняемый модуль.
// все команды exit заменены на return.
function myTxtProcessing(myProgramTitul, myHour,myMinutes,myPath) { // TP
var myProgressPanel;
var myMaximumValue = 13; // число обновлений шкалы текущего состояния обработки — вызова функции myStepByStep()
var myProgressBarWidth = 900;
var myTwoDigitMinutes;
var myTwoDigitHour;
if (myHour <10) myTwoDigitHour = "0" + myHour else myTwoDigitHour = myHour;
if (myMinutes <10)  myTwoDigitMinutes = "0"+myMinutes else myTwoDigitMinutes = myMinutes;
var myInfoProgressLine = myProgramTitul + " (Время начала обработки: " +myTwoDigitHour+":"+myTwoDigitMinutes+")" ;
var myIncrement = myMaximumValue/myProgressBarWidth;
//myCreateProgressPanel(myMaximumValue, myProgressBarWidth,myInfoProgressLine); // myProgressIndex/myIncrement
var myProgressIndex=1;
// Выводим на экран окно состояния выполнения работы
if (myDebug == false) { //DW
	myProgressPanel = myCreateProgressPanel(myMaximumValue, myProgressBarWidth,myInfoProgressLine);
	myProgressPanel.show();
} //DW
// Простые замены
if (myText.characters.firstItem().contents == " ") myText.characters.firstItem().remove(); //удаляем пробел в начале текста
myText.insertionPoints[0].contents = "\r"; // Для случая, если текст начинается предложением, в котором между многоточием и первой буквой текста стоит пробел
myText.insertionPoints[-1].contents = "\r"; // В ходе отладки выяснилось, что процедура поиска оборванных абзацев myTornParagraph() сбивается на последнем абзаце, 
// если он не завершен нормально знаком перевода строки. 
// Поэтому ставим этот знак принудительно.
// добавим пробелы перед скобками [ и (,  и после г.
// Если их окажется два, программа на следующем шаге приведет все в порядок. 
// Эта процедура гарантирует, что потом при замене перед скобками обычных пробелов на неразрывные ни одна из скобок пропущена не будет.
// Также так решается вопрос пропуска пробела при наборе г.Москва.
// В плане быстродействия это решение лучше, нежели позже искать ^9[ и ^$( и пр.
mySimpleChange("("," (");
mySimpleChange("["," [");
mySimpleChange("г.","г. ");
myDigitAndLetter(); // пару цифра-буква разбиваем пробелом   
// Замена 'Дж.' на 'Дж. '. Идем на добавление возможно лишнего пробела из-за того, что в случае двойного имени Дж.Дж.
// поиск "Дж.^$" не работает. Находится только первое 'Дж.', а вторая буква Д попадает в маску как знак $, 
// поэтому программа продолжает поиск со вторй буквы ж. Вот такая тонкая ошибка. Специально делаю акцент на этом,
// чтобы не забыть. Не исключено, что встретятся другие подобные случаи. Сейчас блок проверки "Дж.^$" закомментирован, 
// т.к. мы принудительно ставим после Дж. пробел.
// На будущее, эту задачу надо решать при помощи GREP.
mySimpleChange(" Дж."," Дж. ");
// в текстах сокращение "святые" оформляется как "св.св." Обработаем это сокращение аналогичным образом
mySimpleChange("св.","св. ");
mySimpleChange("^S"," "); // заменяем неразрывные пробелы на обычные. Обычно это авторская псевдоверстка. 
mySimpleChange("^s"," "); // заменяем неразрывные пробелы на обычные. (При повторной обработке текста приводим его к единому начальному виду.) 
// Дальше в процессе работы будут выполнены правильные замены обычных пробелов на неразрывные
myMinusBeforeDigit(); // ищем пробел и тире (или дефис) перед цифрой и ставим перед цифрой минус
// в следующих восьми заменах после многоточия добавим пробел. Он тут должен быть обязательно. Если он окажется лишний, программа приведет все в порядок.
mySimpleChange("....","… "); // четыре точки на многоточие и пробел
mySimpleChange("….","… "); //  многоточие и точка на многоточие и пробел
mySimpleChange("….",". …"); //  точка и многоточие на точку пробел и многоточие
mySimpleChange(",...",",.. "); // запятая и три точки
mySimpleChange(",…",",.. "); //  запятая и многоточие
mySimpleChange("!...","!.. "); // восклицательный знак и три точки
mySimpleChange("!…","!.. "); // восклицательный знак и многоточие 
mySimpleChange("?...","?.. "); // вопросительный знак и три точки
mySimpleChange("?…","?.. "); // вопросительный знак и многоточие
mySimpleChange(myStrangeTire,"–"); // замена истинного минуса (знак с кодом 0х2212) на короткое тире. С этого момента знака минус в тексте больше нет.
//
if (myTabRemove == 1) { mySimpleChange("^t"," "); } // заменяем табуляторы на пробелы
if (myHyphenationCharsRemove == 1) {
	mySimpleChange(myDescritinaryHyphen,""); // удаляем переносы, которые могли остаться из кварковских файлов
	mySimpleChange(myWinWordHyphen,""); // удаляем переносы программы WinWord
}	
mySimpleRepeatedChange("  "," "); // удаляем повторяющиеся обычные пробелы
// if (myFragment == true) {mySimpleRepeatedChange(myLineBreak + mySpace,myLineBreak);} // удаляем пробелы перед знаком с кодом 0xD
mySimpleRepeatedChange("\r ","\r"); // удаляем пробелы в начале абзаца
// выделение цветом курсивного и полужирного текста (каждое начертание будет иметь свой символьный стиль)
if (mySelectionOn == 1)  myBoldItalicAndIndexSelection();
mySimpleChange("°С","°C"); // замена русской буквы на латинскую
// замену "° С","° C" где первая русская С меняется на латинскую нельзя, т.к. русское с может быть первой буквой слов "северной широты"
//
// пробел перед  °C, это гарантия, что исправится ошибка набора, когда единица измерения температуры идет сразу за цифрой
// латинская буква C
mySimpleChange("° C "," °C "); // теперь температура обозначается так
mySimpleChange("° C."," °C.");
mySimpleChange("° C,"," °C,");
mySimpleChange("° C;"," °C;");
// русская буква C
mySimpleChange("° С "," °C "); // теперь температура обозначается так
mySimpleChange("° С."," °C.");
mySimpleChange("° С,"," °C,");
mySimpleChange("° С;"," °C;");
// На будущее — девять предыдущих строк кода можно оптимизировать в одной процедуре. 
// В качестве отправной точки в размышлениях, как это сделать, можно взять статью М. Борисова "InDesign на автомате", Publish, №7, 2006.
// Но поскольку главное качество программы — работа без ошибок, то добьемся пока именно такой работы, а оптимизацию отложим  на потом
mySimpleRepeatedChange("  "," "); // еще раз удаляем повторяющиеся обычные пробелы // можно было бы '  °C'  на ' °C'
mySimpleChange("--","—"); // заменяем два подряд идущих дефиса на тире
mySimpleChange(myNonbreakingHyphen + myNonbreakingHyphen,"—"); // заменяем два подряд идущих неразрывных дефиса на тире
mySimpleChange("-" + myNonbreakingHyphen,"—"); 
mySimpleChange(myNonbreakingHyphen + "-","—"); 
/* в некоторых гарнтитурах хочется чуть отбить запятую от следующего за ним тире. И бывают заказчики, требующие такое оформление...
mySimpleChange(", —",",^<—"); // Замена пробела после запятой перед тире на тонкую шпацию
mySimpleChange(". —",".^<—"); // Замена пробела после точки перед тире  на тонкую шпацию
mySimpleChange(",-",",^<—"); // Замена  дефиса на тире после запятой. Знаки отбиты тонкой шпацией
mySimpleChange(",–",",^<—"); // Замена  минуса на тире после запятой. Знаки отбиты тонкой шпацией
mySimpleChange(", -",",^<—"); // Замена  дефиса на тире после запятой и пробела. Пробел заменен тонкой шпацией
mySimpleChange(", –",",^<—"); // Замена  минуса на тире после запятой  и пробела. Пробел заменен тонкой шпацией
//  */
mySimpleChange(", —",",—"); // удаление пробела после запятой перед тире
//mySimpleChange(". —",".—"); // удаление пробела после точки перед тире
mySimpleChange(",-",",—"); // Замена  дефиса на тире после запятой
mySimpleChange(",–",",—"); // Замена  минуса на тире после запятой
mySimpleChange(", -",",—"); // Замена  дефиса на тире после запятой и пробела
mySimpleChange(", –",",—"); // Замена  пробела и минуса после запятой на тире 
//
mySimpleChange("...","…"); // Замена трех точек на многоточие
//mySimpleChange(".…","…"); // Замена точки и многоточия на многоточие
//mySimpleChange("….","…"); // Замена многоточия и точки  на многоточие
mySimpleChange(" - ",mySpaceDashSpace); // Замена дефиса, отбитого пробелами на тире со стандартными отбивками
mySimpleChange(" – ",mySpaceDashSpace); // Замена минуса, отбитого пробелами на тире со стандартными отбивками
//mySimpleChange(" — ",mySpaceDashSpace); // Замена тире, отбитого пробелами на тире со стандартными отбивками
//mySimpleChange(" ^t","^t");  //Удаление пробелов перед табулятором
//mySimpleChange("^t ","^t");  //Удаление пробелов после табулятора 	
myProgressIndex = myStepByStep(myProgressPanel,myProgressIndex,myIncrement); // 1
//mySimpleChange("^t^p","^p");   // Удаление табуляторов перед маркером абзаца	
//mySimpleChange("^p^t","^p");   // Удаление табуляторов после маркера абзаца	
mySimpleChange(" .","."); // Удаление пробелов перед точкой
mySimpleChange(" ,",","); // Удаление пробелов перед запятой
mySimpleChange(" ;",";"); // Удаление пробелов перед точкой с запятой
mySimpleChange(" :",":"); // Удаление пробела перед двоеточием
mySimpleChange(" !","!"); // Удаление пробелов перед восклицательным знаком
mySimpleChange(" ?","?"); // Удаление пробела перед вопросительным знаком
mySimpleChange(" %","%"); // Удаление пробелов перед знаком процента %
//mySimpleChange("(с)","©"); // знак авторского права /использовалась русская буква/
//mySimpleChange("(c)","©"); // знак авторского права /использовалась латинская буква/
//mySimpleChange("(R)","®"); // регистрационный знак 
myProgressIndex = myStepByStep(myProgressPanel,myProgressIndex,myIncrement); //2
//Знак градуса от предыдущих чисел не должен быть отбит. ЭТО СПОРНОЕ УТВЕРЖДЕНИЕ: 
// Географические — да, но в градусах измеряют еще температуру. 
// Градусы Цельсия обозначаются °С, т.е это единица измерения, состоящая из двух знаков, поэтому знак градуса не должен идти сразу после цифры,
// а вот единица измерения температуры, состоящая из двух знаков, должна быть отбита от цифры
mySimpleChange(" ‰","‰"); // предполагаем, что знак промилле от предыдущих чисел не должен быть отбит 
if (myViewProc != myProcOnly) { //KZ
	mySimpleChange("%", myProcSeparator + "%");
	mySimpleChange("‰", myProcSeparator + "‰");  
	} //KZ
mySimpleChange(" )",")"); // Удаление пробела перед закрывающей круглой скобкой
mySimpleChange("( ","("); // Удаление пробела после открывающей круглой скобки
mySimpleChange(" ]","]"); // Удаление пробела перед закрывающей квадратной скобкой
mySimpleChange("[ ","["); // Удаление пробела после открывающей квадратной скобки
mySimpleChange(" }","}"); // Удаление пробела перед закрывающей фигурной скобкой
mySimpleChange("{ ","{"); // Удаление пробела после открывающей фигурной скобки
mySimpleChange("^p-","^p—"); // - дефис, подлежащий замене на тире в начале предложения
mySimpleChange("^p–","^p—"); // – минус, подлежащий замене на  тире в начале предложения
//
// mySimpleChange("г.г.","гг.");   // годы
//mySimpleChange("в.в.","вв."); // века  -- закомментировано, т.к. В.В. Путин встречается чаще...  :))
//mySimpleChange("т.т.","тт.");  // товарищи
myProgressIndex = myStepByStep(myProgressPanel,myProgressIndex,myIncrement); //3
myMissedSpace("!"); // ищем случай, когда после восклицательного знака нет пробела и исправляем его
//myMissedSpace("?"); //то же для вопросительного знака
myMissedSpace("…"); //то же для многоточия
myMissedSpace(","); //то же для запятой
myMissedSpace(";"); //то же для точки с запятой
myMissedSpace(":"); //то же для двоеточия
myMissedSpace("—"); //то же для тире
mySimpleChange(" — ",mySpaceDashSpace); // тире с пробелами по сторонам на тире со стандартными отбивками
mySimpleChange(" ^p","^p");   //Удаление пробела перед маркером абзаца
mySimpleChange("^p ","^p");  //Удаление пробела после маркера абзаца 
// Пробел между предложениями   27,12,2007 ЭТА ЗАМЕНА ОТКЛЮЧЕНА, Т.К. ТАКИЕ ПРЕДЛОЖЕНИЯ ВСТРЕЧАЮТСЯ РЕДКО, А ВОТ АДРЕСА САЙТОВ И ЭЛ.АДРЕСА ОНА ПОРТИТ ПОСТОЯННО
// Неразрывный пробел между цифрой и г., т.е., было например 1954г., будет 1954 г.
//myDigitAndUnit("^9г."); // маска поиска 'любая цифра''г.'
//myDigitAndUnit("^9в."); // маска поиска 'любая цифра''в.'  (век)
// Неразрывный пробел между цифрой и гг., т.е., было например 1950–1960гг., будет 1950–1960 гг.
//myDigitAndUnit("^9гг."); // маска поиска 'любая цифра''гг.'
//myDigitAndUnit("^9вв."); // маска поиска 'любая цифра''вв.' (века)
myDigitAndUnit("Iвв."); // маска поиска 'римская цифра''вв.' (века)
myDigitAndUnit("Vвв."); // маска поиска 'римская цифра''вв.' (века)
myDigitAndUnit("Xвв."); // маска поиска 'римская цифра''вв.' (века) (X - латинская)
myDigitAndUnit("Хвв."); // маска поиска 'римская цифра''вв.' (века) (X - русская)
myVek("I век"); //  маска поиска 'римская цифра' 'век'
myVek("V век"); //  маска поиска 'римская цифра' 'век'
myVek("X век"); //  маска поиска 'римская цифра' 'век'  (X - латинская)
myVek("Х век"); //  маска поиска 'римская цифра' 'век'  (X - русская)
myDigitAndUnit("Iв."); 
myDigitAndUnit("Vв.");
myDigitAndUnit("Xв."); // (X - латинская)
myDigitAndUnit("Хв."); // (X - русская)
myDigitAndUnitAndSpace("I в."); 
myDigitAndUnitAndSpace("V в.");
myDigitAndUnitAndSpace("X в.");  // (X - латинская)
myDigitAndUnitAndSpace("Х в.");  // (X - русская)
myDigitAndUnitAndSpace("^9 в.");
//myDigitAndUnit("^9г.г."); // маска поиска 'любая цифра''г.г.'
//myDigitAndUnit("^9в.в."); // маска поиска 'любая цифра''в.в.'
myDigitAndUnit("Iв.в."); // маска поиска 'римская цифра''в.в.'
myDigitAndUnit("Vв.в."); // маска поиска 'римская цифра''в.в.'
myDigitAndUnit("Xв.в."); // маска поиска 'римская цифра''в.в.'  // (X - латинская)
myDigitAndUnit("Xв.в."); // маска поиска 'римская цифра''в.в.'  // (X - 	русская)
myRimDigitInterval(); // интервал в датах, указанных римскими цифрами, не должен содержать дефиса
//mySimpleChange("myNonBreakableSpaceVariableWidth"+"г.г.","myNonBreakableSpaceVariableWidth"+" гг."); // Замена г.г. на гг.
// Неразрывный пробел между цифрой и руб. 
//myDigitAndUnit("^9руб."); // маска поиска 'любая цифра''руб.'
// Неразрывный пробел между цифрой и долл.
//myDigitAndUnit("^9долл."); // маска поиска 'любая цифра''долл.'
// Неразрывный пробел между цифрой и евро 
//myDigitAndUnit("^9евро"); // маска поиска 'любая цифра''евро'
// Неразрывный пробел между знаком номера и цифрой
myDigitAndUnit("№^9"); // маска поиска 'номер''любая цифра'
myDigitAndUnit("§^9"); // маска поиска 'параграф''любая цифра'
mySimpleChange("№ ","№"+myNonBreakableSpaceVariableWidth); //  неразрывный пробел после знака номера
mySimpleChange("§ ","§"+myNonBreakableSpaceVariableWidth);     //  неразрывный пробел после знака параграфа
// Неразрывный пробел между цифрой и знаком градусов Цельсия
//myDigitAndUnit("^9°С",1); // маска поиска 'любая цифра''знак градуса' 'русская буква С'
myDigitAndUnit("^9°C"); // маска поиска 'любая цифра''знак градуса' 'латинская буква С'
//
myV_V_G_G  ("в.в."); //поиск букв в.в., стоящих после цифры и пробела
myV_V_G_G  ("г.г."); //поиск букв г.г., стоящих после цифры и пробела
//
myProgressIndex = myStepByStep(myProgressPanel,myProgressIndex,myIncrement); //4
// Минус между цифрами
myMinusInserting("^9-^9");  // маска поиска 'любая цифра' 'дефис' 'любая цифра'
myMinusInserting("^9—^9");  // маска поиска 'любая цифра' 'тире' 'любая цифра'
myMinusInserting("^9" + myNonbreakingHyphen + "^9");  // маска поиска 'любая цифра' 'неразрывный дефис' 'любая цифра'
//
// Если между цифрами были пробел-дефис-пробел, они уже заменены на тире со стандартными отбивками
myMinusBetweenDigits("^9"+mySpaceDashSpace+"^9",2,3);
//Замена пробел-минус-пробел между цифрами на минус
myMinusBetweenDigits("^9 – ^9",2,3);  // маска поиска 'любая цифра''пробел' 'минус''пробел' 'любая цифра'
//Замена пробел-дефис между цифрами на минус
//myMinusBetweenDigits("^9 -^9",2,2);  // маска поиска 'любая цифра''пробел''дефис''любая цифра' 
//Замена дефис-пробел между цифрами на минус
myMinusBetweenDigits("^9- ^9",2,2);  // маска поиска 'любая цифра''дефис''пробел''любая цифра' 
//Замена тире-пробел между цифрами на минус
myMinusBetweenDigits("^9— ^9",2,2);  // маска поиска 'любая цифра''тире''пробел''любая цифра' 
//Замена пробел-тире между цифрами на минус
//myMinusBetweenDigits("^9 —^9",2,2);  // маска поиска 'любая цифра''пробел''тире''любая цифра' 
// присвоение минусу между цифрами атрибута NoBreak
mySetNoBreak("^9–^9");
//////////////////////////////////////////////////////////////////////////////
mySimpleChange(mySpace + myForcedLineBreak ,myForcedLineBreak); // удаление пробелов после символа принудительного перевода строки, если они есть
mySimpleChange(myForcedLineBreak + mySpace,myForcedLineBreak); // удаление пробелов перед символом принудительного перевода строки, если они есть
 if (myPhoneProcessing == true)  myRightPhoneNote(); // упорядочение записи номеров телефонов
// если в меню выбран неразрывный дефис в качестве разделителя между цифрами в датах и числовых интервалах, то эта замена делается тут
 if (myInterDigitSeparator == myInterDigitTire) mySelectedInterDigitSign(); 
// Сокращение г. отделяется от цифр года неразрывным пробелом
myNobrkSpaceInserting("^9 ^$",1);  // маска поиска 'любая цифра''пробел' 'г.'  
//решено взять более общий случай: пробел между цифрой и буквой на неразрывный пробел
//Неразрывный пробел между цифрой и символом "°C"
myNobrkSpaceInserting("^9 °C",1); // маска поиска 'любая цифра''пробел''°C'
myNoBreakedChars(); // слова, начинающиеся и заканчивающиеся буквами НЕ или НИ
myOneLetterDefisWord(); // слова, начинающиеся с одной буквы, затем дефис и слово -- этот дефис делаем неразрывным
// myNobrkSpaceInserting(myNonBreakableSpaceVariableWidth + "не^$",-1);  
//
// Неразрывный пробел между цифрой и °С
//myNobrkSpaceInserting("^9 °С ",1); // маска поиска 'цифра''пробел''знак градуса''буква С (русская)'
myNobrkSpaceInserting("^9 °C ",1); // маска поиска 'цифра''пробел''знак градуса''буква С (латинская)'
// Неразрывный пробел между буквой и римской цифрой
myNobrkSpaceInserting("^$ I",1);  // маска поиска 'любая буква''пробел''римская цифра I' 
myNobrkSpaceInserting("^$ V",1);  // маска поиска 'любая буква''пробел''римская цифра V' 
myNobrkSpaceInserting("^$ X",1);  // маска поиска 'любая буква''пробел''римская цифра X' 
//
myProgressIndex = myStepByStep(myProgressPanel,myProgressIndex,myIncrement); //5
//Замена пробел-дефис между цифрой и буквой на неразбиваемый дефис
myNonBreakHyphBetweenDigitAndLetter("^9 -^$",0);  // маска поиска 'любая цифра''пробел''дефис''любая буква' 
//Замена дефис-пробел между цифрой и буквой на неразбиваемый дефис
myNonBreakHyphBetweenDigitAndLetter("^9- ^$",0);  // маска поиска 'любая цифра''дефис''пробел''любая буква' 
//Замена дефиса между цифрой и буквой на неразбиваемый дефис
myNonBreakHyphBetweenDigitAndLetter("^9-^$",1);  // маска поиска 'любая цифра''дефис''любая буква' 
// во-первых, во-вторых, в-третьих... обычный дефис (а также 'пробел''дефис' и 'дефис'' пробел')  заменяем на неразрывный дефис
myVopreviykh("в");
myVopreviykh("во");
mySetRightSpaceBetweenDigits();
mySetRightSpaceBetweenDigits(); // эта процедура должна вызываться дважды
if (myAugmentSelection == 1) myAugment (); // исправление неверных наращений чисел
if (myDeleteRepeatedEnter == true) {
	mySimpleRepeatedChange("^n^n","^n"); // удаляем повторяющиеся маркеры конца строки
	mySimpleRepeatedChange("^p^p","^p"); // удаляем повторяющиеся маркеры абзаца
	}
// В инициалах А.С. Пушкин или А. С. Пушкин или А.С.Пушкин между буквами инициалов ставим тонкую шпацию, перед фамилией -- myFamilySpace
// три символа "любая буква" в маске фамилии -- попытка найти компромисс между возможным сокращением и записью имени.
// Двухбуквенные фамилии встречаются редко (русский художник Ге), а трехбуквенных сокращений, разделенных точкой, пока не припомню.
// А.С. Пушкин
app.findTextPreferences = app.changeTextPreferences = NothingEnum.nothing;
// if (myFragment == true) { app.findChangeTextOptions.includeFootnotes = false; } else { app.findChangeTextOptions.includeFootnotes = true; }
app.findChangeTextOptions.includeFootnotes = true;
app.findTextPreferences.findWhat = "^$.^$. ^$^$^$"; // маска поиска
myFound = myText.findText(); //собрана коллекция искомых элементов в статье.
if (myFound.length !=0) { //L5
// цикл по числу элементов коллекции. Движение снизу вверх
    for (j=myFound.length-1; j >= 0; j--){ // N5	
	myLine = myFound[j] ;
	var myCh1 = myLine.characters.item(0).contents;
	var myCh2 = myLine.characters.item(2).contents;
	var myCh3 = myLine.characters.item(5).contents;
// если буквы слов в выборке, похожей на фамилию поэта -- строчные, то не обрабатываем эту ситуацию	
if 	(myUpperCaseLetterIs(myCh1) == false) { continue; } 
if 	(myUpperCaseLetterIs(myCh2) == false) { continue; }
if 	(myUpperCaseLetterIs(myCh3) == false) { continue; }
// вставляем тонкую шпацию после точки первого инициала
myLine.insertionPoints[2].contents = myThinSpace;
// перед фамилией заменяем обычный пробел на шпацию myFamilySpace
myLine.characters.item(5).contents  = myFamilySpace;	
	} //N5
} //L5
// А. С.Пушкин
app.findTextPreferences = app.changeTextPreferences = NothingEnum.nothing;app.findChangeTextOptions.includeFootnotes = true;
app.findTextPreferences.findWhat = "^$. ^$.^$^$^$"; // маска поиска
myFound = myText.findText(); //собрана коллекция искомых элементов в статье.
if (myFound.length !=0) { //L5*
// цикл по числу элементов коллекции. Движение снизу вверх
    for (j=myFound.length-1; j >= 0; j--){ // N5*	
	myLine = myFound[j] ;
	var myCh1 = myLine.characters.item(0).contents;
	var myCh2 = myLine.characters.item(3).contents;
	var myCh3 = myLine.characters.item(5).contents;
// если буквы слов в выборке, похожей на фамилию поэта -- строчные, то не обрабатываем эту ситуацию	
if 	(myUpperCaseLetterIs(myCh1) == false) { continue; } 
if 	(myUpperCaseLetterIs(myCh2) == false) { continue; }
if 	(myUpperCaseLetterIs(myCh3) == false) { continue; }
// вставляем пробел на тонкую шпацию после точки первого инициала
myLine.characters.item(2).contents  = myThinSpace;	
// перед фамилией вставляем шпацию myFamilySpace
myLine.insertionPoints[5].contents = myFamilySpace;
	} //N5*
} //L5*
myProgressIndex = myStepByStep(myProgressPanel,myProgressIndex,myIncrement); //6
// А. С. Пушкин
app.findTextPreferences = app.changeTextPreferences = NothingEnum.nothing;
// if (myFragment == true) { app.findChangeTextOptions.includeFootnotes = false; } else { app.findChangeTextOptions.includeFootnotes = true; }
app.findChangeTextOptions.includeFootnotes = true;
app.findTextPreferences.findWhat = "^$. ^$. ^$^$^$"; // маска поиска
myFound = myText.findText(); //собрана коллекция искомых элементов в статье.
if (myFound.length !=0) { //L5
// цикл по числу элементов коллекции. Движение снизу вверх
    for (j=myFound.length-1; j >= 0; j--){ // N5	
	myLine = myFound[j] ;
	var myCh1 = myLine.characters.item(0).contents;
	var myCh2 = myLine.characters.item(3).contents;
	var myCh3 = myLine.characters.item(6).contents;
// если буквы слов в выборке, похожей на фамилию поэта -- строчные, то не обрабатываем эту ситуацию	
if 	(myUpperCaseLetterIs(myCh1) == false) { continue; } 
if 	(myUpperCaseLetterIs(myCh2) == false) { continue; }
if 	(myUpperCaseLetterIs(myCh3) == false) { continue; }
//заменяем пробел после точки первого инициала на тонкую шпацию 
myLine.characters.item(2).contents = myThinSpace;
// перед фамилией  пробел меняем на шпацию myFamilySpace
myLine.characters.item(5).contents  = myFamilySpace;
	} //N5
} //L5
myProgressIndex = myStepByStep(myProgressPanel,myProgressIndex,myIncrement); //7
// А.С.Пушкин
app.findTextPreferences = app.changeTextPreferences = NothingEnum.nothing;
// if (myFragment == true) { app.findChangeTextOptions.includeFootnotes = false; } else { app.findChangeTextOptions.includeFootnotes = true; }
app.findChangeTextOptions.includeFootnotes = true;
app.findTextPreferences.findWhat = "^$.^$.^$^$^$"; // маска поиска
myFound = myText.findText(); //собрана коллекция искомых элементов в статье.
if (myFound.length !=0) { //L5
// цикл по числу элементов коллекции. Движение снизу вверх
    for (j=myFound.length-1; j >= 0; j--){ // N5	
	myLine = myFound[j] ;
	var myCh1 = myLine.characters.item(0).contents;
	var myCh2 = myLine.characters.item(2).contents;
	var myCh3 = myLine.characters.item(4).contents;
// если буквы слов в выборке, похожей на фамилию поэта -- строчные, то не обрабатываем эту ситуацию	
if 	(myUpperCaseLetterIs(myCh1) == false) { continue; } 
if 	(myUpperCaseLetterIs(myCh2) == false) { continue; }
if 	(myUpperCaseLetterIs(myCh3) == false) { continue; }
// вставляем тонкую шпацию после точки первого инициала
myLine.insertionPoints[2].contents = myThinSpace;
// пробел перед фамилией ставим шпацию myFamilySpace
myLine.insertionPoints[5].contents  = myFamilySpace;	
	} //N5
} //L5
// В составных инициалах типа Ф.-Й. Радермахер или А.-М. Четто перед фамилией ставим шпацию myFamilySpace
app.findTextPreferences = app.changeTextPreferences = NothingEnum.nothing;
// if (myFragment == true) { app.findChangeTextOptions.includeFootnotes = false; } else { app.findChangeTextOptions.includeFootnotes = true; }
app.findChangeTextOptions.includeFootnotes = true;
app.findTextPreferences.findWhat = "^$.-^$. ^$^$"; // маска поиска
myFound = myText.findText(); //собрана коллекция искомых элементов в статье.
if (myFound.length !=0) { //L5@
// цикл по числу элементов коллекции. Движение снизу вверх
    for (j=myFound.length-1; j >= 0; j--){ // N5@	
	myLine = myFound[j] ;
	var myCh1 = myLine.characters.item(0).contents;
	var myCh2 = myLine.characters.item(3).contents;
	var myCh3 = myLine.characters.item(6).contents;
// если буквы слов в выборке, похожей на фамилию поэта -- строчные, то не обрабатываем эту ситуацию	
if 	(myUpperCaseLetterIs(myCh1) == false) { continue; } 
if 	(myUpperCaseLetterIs(myCh2) == false) { continue; }
if 	(myUpperCaseLetterIs(myCh3) == false) { continue; }	
// заменяем пробел на шпацию myFamilySpace
myLine.characters.item(5).contents   = myFamilySpace;
	} //N5@
} //L5@
myProgressIndex = myStepByStep(myProgressPanel,myProgressIndex,myIncrement); //8
// В инициалах Пушкин А.С. или Пушкин А. С. после фамилии ставим шпацию myFamilySpace, между буквами инициалов — тонкую шпацию
// Пушкин А.С. 
app.findTextPreferences = app.changeTextPreferences = NothingEnum.nothing;
//if (myFragment == true) { app.findChangeTextOptions.includeFootnotes = false; } else { app.findChangeTextOptions.includeFootnotes = true; }
app.findChangeTextOptions.includeFootnotes = true;
app.findTextPreferences.findWhat = "^$ ^$.^$."; // маска поиска
myFound = myText.findText(); //собрана коллекция искомых элементов в статье.
if (myFound.length !=0) { //L5
// цикл по числу элементов коллекции. Движение снизу вверх
    for (j=myFound.length-1; j >= 0; j--){ // N5	
	var myLine = myFound[j] ;
	var myCh1 = myLine.characters.item(2).contents;
	var myCh2 = myLine.characters.item(4).contents;
// если буквы слов в выборке, похожей на фамилию поэта -- строчные, то не обрабатываем эту ситуацию	
	if 	(myUpperCaseLetterIs(myCh1) == false) { continue; } 
	if 	(myUpperCaseLetterIs(myCh2) == false) { continue; }
/*	var myInd = myLine.characters.item(0).index; // индекс первого символа выборки myLine. 
	var myLineParent = myLine.parent;
	myLineParent.characters.item(myInd).select(); // эта строка корректно указывает на положение выборки myLine в статье: это могут быть, Story, Footnote, Cell. Поэтому уточнение, выполнявшееся ранее, не нужно.
	/*     // уточняем, откуда получено значение myLine -- из статьи или из сносок к ней.
	if (myLineParent.constructor.name == "Story") { //ON
	myText.characters.item(myInd).select();
	}  //ON
	if (myLineParent.constructor.name == "Footnote") { //UB
	myLineParent.characters.item(myInd).select();
	}  //UB  */
	//var myWordInStory = app.selection[0].words[0].contents; // получен доступ к слову, один из симвлолов которого был несколько строк ранее частью myLine   */
var myWordInStory = myLine.characters.item(0).words[0].contents; // слово, в котором 0-й символ из выборки	
if 	(myUpperCaseLetterIs(myWordInStory[0]) == false) { continue; } 
//заменяем пробел после фамилии на спец. шпацию
	myLine.characters.item(1).contents  = myFamilySpace;
// вставляем тонкую шпацию после точки первого инициала
	myLine.insertionPoints[4].contents = myThinSpace;
	} //N5
} //L5
myProgressIndex = myStepByStep(myProgressPanel,myProgressIndex,myIncrement); //9
// Пушкин А. С. 
app.findTextPreferences = app.changeTextPreferences = NothingEnum.nothing;
// if (myFragment == true) { app.findChangeTextOptions.includeFootnotes = false; } else { app.findChangeTextOptions.includeFootnotes = true; }
app.findChangeTextOptions.includeFootnotes = true;
app.findTextPreferences.findWhat = "^$ ^$. ^$."; // маска поиска
myFound = myText.findText(); //собрана коллекция искомых элементов в статье.
if (myFound.length !=0) { //L5
// цикл по числу элементов коллекции. Движение снизу вверх
    for (j=myFound.length-1; j >= 0; j--){ // N5	
	myLine = myFound[j] ;
	var myCh1 = myLine.characters.item(2).contents;
	var myCh2 = myLine.characters.item(5).contents;
// если буквы слов в выборке, похожей на фамилию поэта -- строчные, то не обрабатываем эту ситуацию	
	if 	(myUpperCaseLetterIs(myCh1) == false) { continue; } 
	if 	(myUpperCaseLetterIs(myCh2) == false) { continue; }
	var myWordInStory = myLine.characters.item(0).words[0].contents; // слово, в котором 0-й символ из выборки
	if 	(myUpperCaseLetterIs(myWordInStory[0]) == false) { continue; }
//заменяем пробел после фамилии на шпацию myFamilySpace
	myLine.characters.item(1).contents  = myFamilySpace;	
// заменяем пробел после точки первого инициала на тонкую шпацию 
	myLine.characters.item(4).contents   = myThinSpace;
	} //N5
} //L5
// В инициалах А. Пушкин или А.Пушкин ставим перед фамилией шпацию myFamilySpace
// А.Пушкин
app.findTextPreferences = app.changeTextPreferences = NothingEnum.nothing;
// if (myFragment == true) { app.findChangeTextOptions.includeFootnotes = false; } else { app.findChangeTextOptions.includeFootnotes = true; }
app.findChangeTextOptions.includeFootnotes = true;
app.findTextPreferences.findWhat = "^$.^$^$^$"; // маска поиска
myFound = myText.findText(); //собрана коллекция искомых элементов в статье.
if (myFound.length !=0) { //L5
// цикл по числу элементов коллекции. Движение снизу вверх
    for (j=myFound.length-1; j >= 0; j--){ // N5	
	myLine = myFound[j] ;
	var myCh1 = myLine.characters.item(0).contents;
	var myCh2 = myLine.characters.item(2).contents;
// если буквы слов в выборке, похожей на фамилию поэта -- строчные, то не обрабатываем эту ситуацию	
if 	(myUpperCaseLetterIs(myCh1) == false) { continue; } 
if 	(myUpperCaseLetterIs(myCh2) == false) { continue; }
// вставляем шпацию myFamilySpace после точки инициала
myLine.insertionPoints[2].contents = myFamilySpace;
	} //N5
} //L5
// А. Пушкин
app.findTextPreferences = app.changeTextPreferences = NothingEnum.nothing;
// if (myFragment == true) { app.findChangeTextOptions.includeFootnotes = false; } else { app.findChangeTextOptions.includeFootnotes = true; }
app.findChangeTextOptions.includeFootnotes = true;
app.findTextPreferences.findWhat = "^$. ^$^$^$"; // маска поиска
myFound = myText.findText(); //собрана коллекция искомых элементов в статье.
if (myFound.length !=0) { //L5-
// цикл по числу элементов коллекции. Движение снизу вверх
    for (j=myFound.length-1; j >= 0; j--){ // N5-	
	myLine = myFound[j] ;
	var myCh1 = myLine.characters.item(0).contents;
	var myCh2 = myLine.characters.item(3).contents;
// если буквы слов в выборке, похожей на фамилию поэта -- строчные, то не обрабатываем эту ситуацию	
if 	(myUpperCaseLetterIs(myCh1) == false) { continue; } 
if 	(myUpperCaseLetterIs(myCh2) == false) { continue; }
// заменяем пробел после  точки инициала на шпацию myFamilySpace
myLine.characters.item(2).contents   = myFamilySpace;
 }  // N5-
} //L5-
// В случае сокращения имени Дж. пробел перед фамилией заменяем на шпацию myFamilySpace
// (операции удаления лишних пробелов уже обеспечили, что между именем и фамилией стоит ровно один пробел.)
app.findTextPreferences = app.changeTextPreferences = NothingEnum.nothing;
// if (myFragment == true) { app.findChangeTextOptions.includeFootnotes = false; } else { app.findChangeTextOptions.includeFootnotes = true; }
app.findChangeTextOptions.includeFootnotes = true;
app.findTextPreferences.findWhat = "Дж. "; // маска поиска
myFound = myText.findText(); //собрана коллекция искомых элементов в статье.
if (myFound.length !=0) { //L5*
// цикл по числу элементов коллекции. Движение снизу вверх
    for (j=myFound.length-1; j >= 0; j--){ // N5*	
	myLine = myFound[j] ;
	var myCh1 = myLine.characters.item(0).contents;
// если буквы слов в выборке, похожей на фамилию поэта -- строчные, то не обрабатываем эту ситуацию	
if 	(myUpperCaseLetterIs(myCh1) == false) { continue; } 
// заменяем пробел после  имени на шпацию myFamilySpace
myLine.characters.item(-1).contents   = myFamilySpace;
	} //N5*
} //L5*
// То же для Ан. -- сокращения от Анри (встретил такое в книге М. Митурича "Записки Художника" на с. 17 и 18 )
app.findTextPreferences = app.changeTextPreferences = NothingEnum.nothing;
// if (myFragment == true) { app.findChangeTextOptions.includeFootnotes = false; } else { app.findChangeTextOptions.includeFootnotes = true; }
app.findChangeTextOptions.includeFootnotes = true;
app.findTextPreferences.findWhat = "Ан. "; // маска поиска
myFound = myText.findText(); //собрана коллекция искомых элементов в статье.
if (myFound.length !=0) { //L5*
// цикл по числу элементов коллекции. Движение снизу вверх
    for (j=myFound.length-1; j >= 0; j--){ // N5*	
	myLine = myFound[j] ;
	var myCh1 = myLine.characters.item(0).contents;
// если буквы слов в выборке, похожей на фамилию поэта -- строчные, то не обрабатываем эту ситуацию	
if 	(myUpperCaseLetterIs(myCh1) == false) { continue; } 
// заменяем пробел после  имени на шпацию myFamilySpace
myLine.characters.item(-1).contents   = myFamilySpace;
	} //N5*
} //L5*
// В случае сокращения  "св." пробел после этого сокращения заменяем на фиксированный неразрывный пробел.
// (операции удаления лишних пробелов уже обеспечили, что тут только один пробел.)
app.findTextPreferences = app.changeTextPreferences = NothingEnum.nothing;
//if (myFragment == true) { app.findChangeTextOptions.includeFootnotes = false; } else { app.findChangeTextOptions.includeFootnotes = true; }
app.findChangeTextOptions.includeFootnotes = true;
app.findTextPreferences.findWhat = "св. "; // маска поиска
myFound = myText.findText(); //собрана коллекция искомых элементов в статье.
if (myFound.length !=0) { //L5*+
// цикл по числу элементов коллекции. Движение снизу вверх
    for (j=myFound.length-1; j >= 0; j--){ // N5*+	
	myLine = myFound[j] ;
// заменяем пробел после  имени на фиксированный неразрывный пробел 
myLine.characters.item(-1).contents   = myNonBreakableSpaceFixedWidth;
	} //N5*+
} //L5*+
myProgressIndex = myStepByStep(myProgressPanel,myProgressIndex,myIncrement); //10
// В инициалах Пушкин А. ставим после фамилии шпацию myFamilySpace 
// Пушкин А.
app.findTextPreferences = app.changeTextPreferences = NothingEnum.nothing;
// if (myFragment == true) { app.findChangeTextOptions.includeFootnotes = false; } else { app.findChangeTextOptions.includeFootnotes = true; }
app.findChangeTextOptions.includeFootnotes = true;
app.findTextPreferences.findWhat = "^$^$^$ ^$." ; // маска поиска
myFound = myText.findText(); //собрана коллекция искомых элементов в статье.
if (myFound.length !=0) { //L5~
// цикл по числу элементов коллекции. Движение снизу вверх
    for (j=myFound.length-1; j >= 0; j--){ // N5~	
	myLine = myFound[j] ;
	var myPoetName = myLine.characters.item(2).words[0].contents; // слово, в котором 2-й символ из выборки
	var myCh1 = myLine.characters.item(4).contents;
// если буквы слов в выборке, похожей на фамилию поэта -- строчные, то не обрабатываем эту ситуацию	
if 	(myUpperCaseLetterIs(myCh1) == false) { continue; } 
myCh1 = myPoetName[0]; // первая буква слова, похожего на фамилию
if 	(myUpperCaseLetterIs(myCh1) == false) { continue; } 
//заменяем пробел после фамилии на шпацию myFamilySpace
myLine.characters.item(-3).contents  = myFamilySpace;
 }  // N5~
} //L5~
//
// в сокращениях т.д. и т.п. между буквами ставим тонкую шпацию
myTwoLetterAbridge();
//myTeDe_I_TePe();
myWordDotDigit("рис"); //  если после этого слова идет точка и сразу цифра, то перед цифрой ставим неразрывный пробел
myWordDotDigit("табл"); 
myWordDotDigit("фиг"); 
myWordDotDigit("т"); 
myWordDotDigit("тт"); // сокращение "тома", обычно после этих букв идут цифры
myWordDotDigit("с"); 
myWordDotDigit("ч"); 
myWordDotDigit("п"); 
myWordDotDigit("пп"); 
myWordDotDigit("стр"); 
// Одно- и двухбуквенные слова, пробелы после них заменяются на неразрывные пробелы 
//myNobrkSpaceInserting(" а ",-1); // маска поиска 'пробел''а''пробел'
//myNobrkSpaceInserting(" не ",-1); // маска поиска 'пробел''не''пробел'
mySimpleChange("г. ","г." + myNonBreakableSpaceVariableWidth); // После сокращения г. (город) ставим неразрывный пробел
//********** 
myProgressIndex = myStepByStep(myProgressPanel,myProgressIndex,myIncrement); //11
// Если в начале абзаца после тире сразу идет текст, он будет отбит пробелом
app.findTextPreferences = app.changeTextPreferences = NothingEnum.nothing;
app.findTextPreferences.findWhat = "^p—^$"; // маска поиска
myFound = myText.findText(); //собрана коллекция искомых элементов в статье.
if (myFound.length !=0) { //L5
// цикл по числу элементов коллекции. Движение снизу вверх
    for (j=myFound.length-1; j >= 0; j--){ // N5	
	myLine = myFound[j] ;
//вставляем после тире пробел 
	myLine.insertionPoints[2].contents  = mySpace;
	} //N5
} //L5 
// Присвоим вариантам символа прямой наклонной черты / и символу обратной наклонной черты  \ и каждому из знаков до и после них атрибут "No break"
mySimpleChange(" /","/");
mySimpleChange("/ ","/");
mySimpleChange(" " + myBackSlash , myBackSlash);
mySimpleChange(myBackSlash +" ", myBackSlash);
mySimpleChange(" " + myFractionSlash , myFractionSlash);
mySimpleChange(myFractionSlash +" ", myFractionSlash);
//
mySetNoBreak(myBackSlash); 
mySetNoBreak("/");
mySetNoBreak(myFractionSlash);
mySetNoBreak("^$–^$"); 
mySetNoBreak("^$—^$"); 
// обработка сокращений, полученных выбрасыванием букв из слова
myMlnMlrd("млн"); 
myMlnMlrd("млрд"); 
myMlnMlrd("трлн");
//myMlnMlrd("кг");
//
mySimpleChange("^p… ","^p…"); // В начале абзаца удаляем пробел между многоточием и первой буквой предложения.
mySpaceDotsSpace();
mySimpleChange("^p— ","^p—" + myNonBreakableSpaceFixedWidth); // пожелание пользователей иметь в диалогах одинаковую отбивку между тире и первой буквой предложения. До этого тут был обычный пробел, говорят, иногда его ширина меняется.
//
// все же надо отбить хоть тонкой шпацией тире от точки , запятой или многоточия
mySimpleChange(",—", "," + myThinSpace +  "—");
mySimpleChange("," + myNonBreakableSpaceFixedWidth +  "—", "," + myThinSpace +  "—");
mySimpleChange("," + myNonBreakableSpaceVariableWidth +  "—", "," + myThinSpace +  "—");
mySimpleChange(".—", "." + myThinSpace +  "—");
mySimpleChange("." + myNonBreakableSpaceFixedWidth +  "—", "." + myThinSpace +  "—");
mySimpleChange("." + myNonBreakableSpaceVariableWidth +  "—", "." + myThinSpace +  "—");
mySimpleChange("…—", "…" + myThinSpace +  "—");
mySimpleChange("…" + myNonBreakableSpaceFixedWidth +  "—", "…" + myThinSpace +  "—");
mySimpleChange("…" + myNonBreakableSpaceVariableWidth +  "—", "…" + myThinSpace +  "—");
// Учтем такие конструкции, когда реплика диалога начинается с многоточия и строчной буквы. В книгах современных авторов такое стало встречаться.
mySimpleChange("^p—" + myNonBreakableSpaceFixedWidth + "…" + mySpace,"^p—" + myNonBreakableSpaceFixedWidth + "…");
//
myFootnoteSignCorection();
//
//myAccent (); -- теперь это отдельная программа
//
// В процессе отладки обнаружено что сокращение г.г. разбивается неразрывным эластичным пробелом, этим же знаком эта группа букв отбивается от цифры.
// А сокращение в. в. только отбивается от цифры таким пробелом.
// Удаляем эту отбивку между буквами.
app.findTextPreferences = app.changeTextPreferences = NothingEnum.nothing;
app.findChangeTextOptions.includeFootnotes = true; 
app.findTextPreferences.findWhat = "^9" + myNonBreakableSpaceVariableWidth +"г." + myNonBreakableSpaceVariableWidth  +"г." ; // маска поиска
myFound = myText.findText(); //собрана коллекция искомых элементов в статье.
if (myFound.length !=0) { //L5
// цикл по числу элементов коллекции. Движение снизу вверх
    for (j=myFound.length-1; j >= 0; j--){ // N5	
	myLine = myFound[j] ;
// удаляем неразрывный пробел
myLine.characters.itemByRange(3,4).remove();
	} //N5
} //L5 
app.findTextPreferences.findWhat = "^9" + myNonBreakableSpaceVariableWidth +"в. в." ; // маска поиска
myFound = myText.findText(); //собрана коллекция искомых элементов в статье.
if (myFound.length !=0) { //L5~
// цикл по числу элементов коллекции. Движение снизу вверх
    for (j=myFound.length-1; j >= 0; j--){ // N5~~
	myLine = myFound[j] ;
// удаляем обычный пробел
myLine.characters.itemByRange(3,4).remove();
	} //N5~~
} //L5~ 
//
// В процессе обработки часто возникает ситуация, что после обработки  после сокращения 'г.' идет тонкая шпация, а затем инициал.
// Надо заменить эту тонкую шпацию на обычный пробел.
app.findTextPreferences = app.changeTextPreferences = NothingEnum.nothing;
app.findChangeTextOptions.includeFootnotes = true; 
app.findTextPreferences.findWhat = "^$." + myThinSpace +"^$." + myThinSpace ; // обобщенный вариант
//app.findTextPreferences.findWhat = "г." + myThinSpace +"^$." + myThinSpace ; // маска поиска, упрощенный вариант
myFound = myText.findText(); //собрана коллекция искомых элементов в статье.
if (myFound.length !=0) { //L5%%
// цикл по числу элементов коллекции. Движение снизу вверх
    for (j=myFound.length-1; j >= 0; j--){ // N5%%	
		myLine = myFound[j] ;
		var myCh0 = myLine.characters.item(0).contents; // последняя буква предполагаемого сокращения
		var myCh3 = myLine.characters.item(3).contents; // первая буква предполагаемого инициала
		if ((myUpperCaseLetterIs(myCh0) != false) || (myUpperCaseLetterIs(myCh3) == false)) { continue; }	//  или в предполагаемом сокращении прописная или в предполагаемом инициале строчная
		// заменяем  тонкую шпацию на пробел 
		myLine.characters.item(2).contents = mySpace;
	} //N5%%
} //L5%% 
//
myProgressIndex = myStepByStep(myProgressPanel,myProgressIndex,myIncrement); //12
if (myForbidShortWords == true) { //JV
myNobrkSpaceAfterShortWord("а");
myNobrkSpaceAfterShortWord("в");
myNobrkSpaceAfterShortWord("и");
myNobrkSpaceAfterShortWord("к");
myNobrkSpaceAfterShortWord("о");
myNobrkSpaceAfterShortWord("с");
myNobrkSpaceAfterShortWord("у");
myNobrkSpaceAfterShortWord("я");
myNobrkSpaceAfterShortWord("не"); // эта проверка заменена на более общую: 'НЕ''пробел' заменяем на 'НЕ''неразрывный_пробел' 
myNobrkSpaceAfterShortWord("на");
myNobrkSpaceAfterShortWord("ну");
myNobrkSpaceAfterShortWord("ни");
myNobrkSpaceAfterShortWord("но");
myNobrkSpaceAfterShortWord("от");
myNobrkSpaceAfterShortWord("из");
myNobrkSpaceAfterShortWord("за");
myNobrkSpaceAfterShortWord("по");
myNobrkSpaceAfterShortWord("до");
myNobrkSpaceAfterShortWord("во");
myNobrkSpaceAfterShortWord("то");
myNobrkSpaceAfterShortWord("со");
myNobrkSpaceAfterShortWord("ко");
myNobrkSpaceAfterShortWord("об");
myNobrkSpaceAfterShortWord("см.");
myNobrkSpaceAfterShortWord("им.");
myNobrkSpaceAfterShortWord("с.");
myNobrkSpaceAfterShortWord("т.");
myNobrkSpaceAfterShortWord("п.");
myNobrkSpaceAfterShortWord("ч.");
myNobrkSpaceAfterShortWord("рис.");
myNobrkSpaceAfterShortWord("фиг.");
myNobrkSpaceAfterShortWord("табл.");
myNobrkSpaceAfterShortWord("тт."); // сокращение "товарищи"
myNobrkSpaceAfterShortWord("гр."); // сокращение "гражданин"
myNobrkSpaceAfterShortWord("гр-ка"); // сокращение "гражданка"
myNobrkSpaceAfterShortWord("г-н"); // сокращение "господин"
myNobrkSpaceAfterShortWord("г-жа"); // сокращение "госпожа"
myNobrkSpaceAfterShortWord("кн."); // сокращение "князь"
myNobrkSpaceAfterShortWord("тов."); // сокращение "товарищ"
} //JV
// 
myProgressIndex = myStepByStep(myProgressPanel,myProgressIndex,myIncrement); //13
//
//myNobrkSpaceBeforeShortWord("[");  
//myNobrkSpaceBeforeShortWord("(");
if (myForbidShortWords == true) { //JW
myNobrkSpaceBeforeShortWord("ли ");
myNobrkSpaceBeforeShortWord("ль");
myNobrkSpaceBeforeShortWord("бы ");
myNobrkSpaceBeforeShortWord("б ");
myNobrkSpaceBeforeShortWord("же ");
myNobrkSpaceBeforeShortWord("же,");
myNobrkSpaceBeforeShortWord("уж ");
myNobrkSpaceBeforeShortWord("уж,");
myNobrkSpaceBeforeShortWord("ж ");
myNobrkSpaceBeforeShortWord("ж,");
myNobrkSpaceBeforeShortWord("а!");
myNobrkSpaceBeforeShortWord("а?");
myNobrkSpaceBeforeShortWord("а…");
myNobrkSpaceBeforeShortWord("да!");
myNobrkSpaceBeforeShortWord("да?");
myNobrkSpaceBeforeShortWord("ли!");
myNobrkSpaceBeforeShortWord("ли?");
myNobrkSpaceBeforeShortWord("ли…");
myNobrkSpaceBeforeShortWord("я!");
myNobrkSpaceBeforeShortWord("я?");
myNobrkSpaceBeforeShortWord("я…");
myNobrkSpaceBeforeShortWord("я.");
myNobrkSpaceBeforeShortWord("уж!");
myNobrkSpaceBeforeShortWord("уж…");
myNobrkSpaceBeforeShortWord("бы!");
myNobrkSpaceBeforeShortWord("бы…");
//myNobrkSpaceBeforeShortWord("в."); // сокращение "века"   -- надо неразрывный пробел ставить не всегда, а только после цифр, арабских или римских
myNobrkSpaceBeforeShortWord("вв."); // сокращение "веков"
}  //JW

// ищутся:  буква-дефис-цифры-неразрывный пробел переменной ширины
var mySearchedCharactersSampleOne = '([А-Яа-яA-Za-z]-[\\d]+[\xA0])';
var mySearchedCharactersSampleTwo = '([А-Яа-яA-Za-z]-[\\d])';

app.findGrepPreferences = NothingEnum.nothing;
app.findGrepPreferences.findWhat = mySearchedCharactersSampleOne;				
myFoundSamples = myText.findGrep();
if (myFoundSamples.length != 0) {
// цикл по числу элементов коллекции. Движение снизу вверх
    for (j=myFoundSamples.length-1; j >= 0; j--) {	
		myLine = myFoundSamples[j] ;
		myLine.characters.itemByRange(-1,-1).remove();	// удаляем неразрывный пробел переменной ширины
		myLine.insertionPoints[-2].contents = mySpace; // вместо него ставим обычный пробел
	}
}
app.findGrepPreferences = NothingEnum.nothing;
app.findGrepPreferences.findWhat = mySearchedCharactersSampleTwo;				
myFoundSamples = myText.findGrep();
if (myFoundSamples.length != 0) {
// цикл по числу элементов коллекции. Движение снизу вверх
    for (j=myFoundSamples.length-1; j >= 0; j--) {	
		myLine = myFoundSamples[j] ;
		mySimpleRepeatedChangeInLine("-",myNonbreakingHyphen,myLine); // обычный дефис в словах типа ИЛ-62 заменён на неразрывный
	}
}
//
myLastLetterOfSentenceFootnoteCorrection("^$." +mySpace + myThinSpace); // исправляем ошибку работы программы, добавляющей пробел (обычный или неразрывный) после 'г.' или  'т.'
myLastLetterOfSentenceFootnoteCorrection("^$." + myNonBreakableSpaceVariableWidth + myThinSpace);
// то же замеченный огрех программы — она может в комментарии оторвать инициалы автора от предшествующего тире и поместить на другую строку
app.findTextPreferences = app.changeTextPreferences = NothingEnum.nothing;
app.findChangeTextOptions.includeFootnotes = true;
app.findTextPreferences.findWhat = "— ^$."+ myThinSpace + "^$."; // буквы во 2 и 5 позициях, пробел — в 1-й
myFound = myText.findText(); //собрана коллекция искомых элементов в статье.
for (j=myFound.length-1; j >= 0; j--){ // N5**	
		myLine = myFound[j] ;
		var myCh0 = myLine.characters.item(2).contents;
		var myCh1 = myLine.characters.item(5).contents;
		if (myUpperCaseLetterIs (myCh0) == true && myUpperCaseLetterIs (myCh1) == true)   // обе буквы прописные
						myLine.characters.item(1).contents  = myNonBreakableSpaceVariableWidth; 
	  } //N5**
//
if (myListsRemove == 1) myText.convertBulletsAndNumberingToText();
if (myHyperlinksRemove == 1) myRemoveHyperLinks();
// в списках и перечнях номер(с точкой) и буллит должны отбиваться от текста неразрывным фиксированным пробелом
myList ("\r^9. ");
myList ("\r^9^9. ");
myList ("\r^9^9^9. ");
myList ("\r• ");
//
//mySetNoBreakStyle(); 
mySimpleChange(" гг.", myNonBreakableSpaceVariableWidth + "гг.");
mySimpleChange(myNonBreakableSpaceVariableWidth +"г."+myNonBreakableSpaceVariableWidth +"г."+myNonBreakableSpaceVariableWidth, myNonBreakableSpaceVariableWidth + "г." + mySpace + "г." + myNonBreakableSpaceVariableWidth);
mySimpleChange(myNonBreakableSpaceVariableWidth +"гг."+myNonBreakableSpaceVariableWidth +"г."+myNonBreakableSpaceVariableWidth, myNonBreakableSpaceVariableWidth + "гг." + mySpace + "г." + myNonBreakableSpaceVariableWidth);
mySimpleChange(myNonBreakableSpaceVariableWidth +"гг."+myNonBreakableSpaceVariableWidth, myNonBreakableSpaceVariableWidth + "гг." + mySpace);
mySimpleChange(myNonBreakableSpaceVariableWidth +"г."+myNonBreakableSpaceVariableWidth, myNonBreakableSpaceVariableWidth + "г." + mySpace);
mySimpleChange(myNonBreakableSpaceVariableWidth + "г." + myThinSpace + "г.", myNonBreakableSpaceVariableWidth + "гг.");
mySimpleChange(myNonBreakableSpaceVariableWidth + "г." + myThinSpace + "н. э.", myNonBreakableSpaceVariableWidth + "г." + myThinSpace + "н." + myThinSpace + "э.");
if (myFragment == false) {
if (myText.characters.firstItem().contents == "\r") myText.characters.firstItem().remove(); // если текст начинается с символа перевода строки, удаляем его
}
//если выбран вариант оформления тире, отличный от mySpaceDashSpace, исправляем тире и отбивки 
if (myDashSeparator != mySpaceDashSpace) { //UC
	// В этой версии предполагается, что в качестве тире могут использоваться только обычное длинное тире или короткое тире (знак минус).
	// поэтому просто заменяем в тексте тире на минус.  Будут другие идеи и обоснованные предложения по модернизации -- сделаю.
	mySimpleChange("—","–"); // замена тире на минус
	} //UC
//
// присвоение всему тексту признака, что язык -- русский
if (mySetRussLangSelection == 1) {
	var myTextObject = myText.texts.item(0);
	try {myTextObject.appliedLanguage = "Russian"; }
	catch (e) {
		try {myTextObject.appliedLanguage = "Русский"; }
		catch (e) { mySetRussLangSelection = 0 } // если не удалось установить язык, то в меню флажок установки языка будет сброшен
	}	
}	
myProgressPanel.hide();

	var mySetInfoFile = new File (myPath);
	mySetInfoFile.open("w");
	mySetInfoFile.writeln(myVidTire);
	mySetInfoFile.writeln(mySepInYears);
	mySetInfoFile.writeln(mySelectedVarPhoneNumber);
	mySetInfoFile.writeln(mySelectedVarDigSeparator);
	mySetInfoFile.writeln(myDotOrNot);
	mySetInfoFile.writeln(myProcMille);
	mySetInfoFile.writeln(myRepEntSel);
	mySetInfoFile.writeln(myVarPredlogs);
	mySetInfoFile.writeln(myMakeIndexStyle);
	mySetInfoFile.writeln(mySemiDigitNumber);
	mySetInfoFile.writeln(myAugmentSelection);
	mySetInfoFile.writeln(mySetRussLangSelection);
	mySetInfoFile.writeln(myTabRemove);
	mySetInfoFile.writeln(myHyphenationCharsRemove);
	mySetInfoFile.writeln(myListsRemove);
	mySetInfoFile.writeln(myHyperlinksRemove);
	mySetInfoFile.close();
	
return;
} // TP
/////////
function myFile(myFileName) { //FC
var myScriptFile = myGetScriptPath();
var myScriptFolder = decodeURI(myScriptFile.path);
var myFilePath = decodeURI(myScriptFolder + "/" +myFileName);
//if(File(myFilePath).exists == false){
		/*Display a dialog.
		myFilePath = File.openDialog("Choose the file containing your find/change list"); */
	//	alert("Не найден файл " +  myFileName + " Он должен быть в том же каталоге, где размещен этот скрипт. ");
	//	exit();
	//	} 
return myFilePath;
} //FC
///////
function myGetScriptPath() { //NM
try{
return app.activeScript;
}
catch(myError){
return File(myError.fileName);
}
} //NM
////
function mySimpleRepeatedChangeInLine(myFindWhat,myChahgeTo,myText) {  //замена в указанном тексте одного набора знаков на другой набор 
app.findTextPreferences = NothingEnum.nothing;
app.changeTextPreferences = NothingEnum.nothing;
app.findTextPreferences.findWhat = myFindWhat;
app.changeTextPreferences.changeTo = myChahgeTo;
myFound = myText.changeText();
while (myFound.length !=0) { //1
    myFound = myText.changeText();
	} //1
} // mySimpleRepeatedChangeInLine
//////
function myRemoveHyperLinks() { // myRemoveHyperLinks
var myFoundedHyperLinks = 0;
if (myDocument.hyperlinks.length > 0){ // if
	for ( j = myDocument.hyperlinks.length; j > 0 ; j--) { // for
         myDocument.hyperlinks[j - 1].remove();
		myFoundedHyperLinks++;		  
      } // for
}  // if
return myFoundedHyperLinks;	
} //myRemoveHyperLinks